	.module _7SegmentDisplay.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\7SegmentDisplay.c
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\7SegmentDisplay.c
_positionScale::
	.blkb 4
	.area idata
	.word 0x4952,0x391d
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\7SegmentDisplay.c
	.dbsym e positionScale _positionScale D
_decimalPlace::
	.blkb 2
	.area idata
	.word 2
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\7SegmentDisplay.c
	.dbsym e decimalPlace _decimalPlace I
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\7SegmentDisplay.c
	.dbfunc e main _main fV
;             ii -> <dead>
	.even
_main::
	.dbline -1
	.dbline 100
; /*! \file
;  *
;  * SOC Robotics, Inc
;  *
;  * File - 7SegmentDisplay.c
;  *
;  * Compiler - ICCAVR 7.16a
;  *
;  * Description  - This file sets the device to act as a TWI Slave
;  * It will process co
;  *
;  * 0xF9DFE6 => External clock
;  *
;  * $Revision: 1.0.1 $
;  * $Date: June 2nd, 2008 $
;  *
;  *   For 20MHz external operation:  
;  *     Fuse settings should be:  F9 D9 E7
;  *
;  * Copyright 2008, SOC Robotics, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC ROBOTICS, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SOC ROBOTICS, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-machines.com/
;  */
; 
; #include <stdio.h>
;  
;  
; #include <iom168v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; #include "Board.h"
; #include "Timer.h" 
; #include "Serial.h"
; #include "TWI_slave.h"
; #include "LED_Display.h"
; 
; unsigned char CheckEEPROMWritten(void);
; 
; void Init_EEPROM(void);
; 
; void  LoadEEPROMSettings(void);
; 
; // Function to initiate an EEPROM write
; // writes the specified data byte to the specified location
; // this will fail if the EEPROM is not ready!
; void RTEEPROMwrite(int location, unsigned char databyte);
; 
; // EEPROM writes take about 8ms - so poll until done
; // Do not use ICC V7 function EEPROMwrite() - this routine turns interrupts off!
; void EEPROMWrite(int location, unsigned char databyte);
; 
; // Write a string of characters to EEPROM at specified start location
; void WriteEEPROM(int location, unsigned char *strg);
; // function to test if the EEPROM is ready for a read or write operation
; // returns non zero if ready, zero if not ready 
; unsigned char RTEEPROMReady(void);
; 
; unsigned char RTEEPROMread(int location);
; 
; 
; void TWIPeripheral(void);
; unsigned char TimeToUpdate(void);
; 
; void watchdog_init(void);
; 
; 
; float positionScale = DEFAULT_POSITION_SCALE;
; int decimalPlace = DEFAULT_DECIMAL_PLACE;
; 
; void main(void)
; {
	.dbline 102
; 	int ii;
; 	CLI();//disable interrupts
	cli
	.dbline 106
;     
;     
;     
; 	Buttons_Init();
	xcall _Buttons_Init
	.dbline 107
;     LED_Init(); 
	xcall _LED_Init
	.dbline 108
;     uart0_init();//incase we get an error in the TWI
	xcall _uart0_init
	.dbline 112
;    // LoadEEPROMSettings();
;    // DDRD |= (1<<0); //hearth beat output
;     
; 	Init_Timer();
	xcall _Init_Timer
	.dbline 113
; 	Init_Timer0();
	xcall _Init_Timer0
	.dbline 115
;     
; 	TWI_Slave_Initialise( TWI_ADDRESS);
	ldi R16,37
	xcall _TWI_Slave_Initialise
	.dbline 119
; 
;  //   watchdog_init();
;   
; 	SEI(); // Enable interrupts
	sei
	.dbline 122
; 
; 	//wait to show the display is working
; 	mseccountdown1 = 1000;
	ldi R24,1000
	ldi R25,3
	sts _mseccountdown1+1,R25
	sts _mseccountdown1,R24
L2:
	.dbline 124
; 	while(mseccountdown1 != 0)
;     {
	.dbline 125
;     	;//WDR ();
	.dbline 126
;     }
L3:
	.dbline 123
	lds R2,_mseccountdown1
	lds R3,_mseccountdown1+1
	tst R2
	brne L2
	tst R3
	brne L2
X0:
	.dbline 127
; 	uart0_puts ("\nStart Peripheral"); 
	ldi R16,<L5
	ldi R17,>L5
	xcall _uart0_puts
	.dbline 129
;     
; 	LED_Clear();  
	xcall _LED_Clear
	.dbline 131
; 	
; 	TWIPeripheral();
	xcall _TWIPeripheral
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbsym l ii 1 I
	.dbend
	.dbfunc e TWIPeripheral _TWIPeripheral fV
;              i -> <dead>
;          value -> R10,R11
;           temp -> y+4
	.even
_TWIPeripheral::
	xcall push_xgset300C
	sbiw R28,44
	.dbline -1
	.dbline 140
; }
; 
; /*!
;  * \brief This function will check to see if it has received new data from
;  * the master.  If it has it will process the data.  It will also update
;  * the values of the boards buttons into the TWI output buffer
;  */
; void TWIPeripheral(void)
; {
	xjmp L8
L7:
	.dbline 149
; 	unsigned char i;
; 
; 	unsigned char temp[TWI_RX_BUFFER_SIZE];
; 	 
; 	//This void pointer is used to cast the transmitted data to the correct type
; 	void *value;
; 
; 	while(1)
; 	{
	.dbline 150
;     	WDR ();
	wdr
	.dbline 153
;         
; 		//if we have received new data, process it
; 		if(TWI_Get_Data_From_Transceiver( temp, TWI_RX_BUFFER_SIZE ))
	ldi R18,40
	movw R16,R28
	subi R16,252  ; offset = 4
	sbci R17,255
	xcall _TWI_Get_Data_From_Transceiver
	tst R16
	brne X19
	xjmp L10
X19:
X1:
	.dbline 154
; 		{
	.dbline 155
; 			value = &temp[1];//my data if any will start at the next byte
	movw R24,R28
	adiw R24,5
	movw R10,R24
	.dbline 157
; 				
; 			switch(temp[0])//what command was sent?
	ldd R20,y+4
	clr R21
	cpi R20,98
	ldi R30,0
	cpc R21,R30
	brne X20
	xjmp L18
X20:
X2:
	cpi R20,100
	ldi R30,0
	cpc R21,R30
	brne X21
	xjmp L22
X21:
X3:
	cpi R20,102
	ldi R30,0
	cpc R21,R30
	brne X22
	xjmp L19
X22:
X4:
	cpi R20,104
	ldi R30,0
	cpc R21,R30
	brne X23
	xjmp L17
X23:
X5:
	cpi R20,105
	ldi R30,0
	cpc R21,R30
	brne X24
	xjmp L16
X24:
X6:
	ldi R24,105
	ldi R25,0
	cp R24,R20
	cpc R25,R21
	brlt L24
X7:
L23:
	cpi R20,0
	cpc R20,R21
	breq L16
X8:
	cpi R20,1
	ldi R30,0
	cpc R21,R30
	brne X25
	xjmp L17
X25:
X9:
	cpi R20,2
	ldi R30,0
	cpc R21,R30
	brne X26
	xjmp L18
X26:
X10:
	cpi R20,3
	ldi R30,0
	cpc R21,R30
	brne X27
	xjmp L19
X27:
X11:
	cpi R20,4
	ldi R30,0
	cpc R21,R30
	brne X28
	xjmp L20
X28:
X12:
	cpi R20,5
	ldi R30,0
	cpc R21,R30
	brne X29
	xjmp L21
X29:
X13:
	cpi R20,6
	ldi R30,0
	cpc R21,R30
	brne X30
	xjmp L22
X30:
X14:
	xjmp L13
L24:
	cpi R20,112
	ldi R30,0
	cpc R21,R30
	brne X31
	xjmp L20
X31:
X15:
	cpi R20,115
	ldi R30,0
	cpc R21,R30
	brne X32
	xjmp L21
X32:
X16:
	xjmp L13
L16:
	.dbline 162
; 			{
; 				case COMMAND_7SEGMENT_WRITE_INT:
; 				case COMMAND_7SEGMENT_WRITE_INT_B:
; 					//Before reading the data, I cast it to the correct type
; 					Display_Int(*(int *)value, 0, DEC);
	ldi R24,10
	ldi R25,0
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	movw R30,R10
	ldd R16,z+0
	ldd R17,z+1
	xcall _Display_Int
	.dbline 163
; 					break;
	xjmp L14
L17:
	.dbline 167
; 					
; 				case COMMAND_7SEGMENT_WRITE_HEX_INT:
; 				case COMMAND_7SEGMENT_WRITE_HEX_INT_B:
; 					Display_Int(*(int *)value, 0, HEX);
	ldi R24,16
	ldi R25,0
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	movw R30,R10
	ldd R16,z+0
	ldd R17,z+1
	xcall _Display_Int
	.dbline 168
; 					break;
	xjmp L14
L18:
	.dbline 172
; 						
; 				case COMMAND_7SEGMENT_WRITE_BIN_INT:
; 				case COMMAND_7SEGMENT_WRITE_BIN_INT_B:
; 					Display_Int(*(int *)value, 0, BIN);
	ldi R24,2
	ldi R25,0
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	movw R30,R10
	ldd R16,z+0
	ldd R17,z+1
	xcall _Display_Int
	.dbline 173
; 					break;
	xjmp L14
L19:
	.dbline 177
; 						
; 				case COMMAND_7SEGMENT_WRITE_FLOAT:
; 				case COMMAND_7SEGMENT_WRITE_FLOAT_B:
; 					Display_Float(*(float *)value,0, decimalPlace);
	lds R2,_decimalPlace
	lds R3,_decimalPlace+1
	std y+3,R3
	std y+2,R2
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	movw R30,R10
	ldd R16,z+0
	ldd R17,z+1
	ldd R18,z+2
	ldd R19,z+3
	xcall _Display_Float
	.dbline 178
; 					break;
	xjmp L14
L20:
	.dbline 182
; 						
; 				case COMMAND_7SEGMENT_WRITE_POSITION:
; 				case COMMAND_7SEGMENT_WRITE_POSITION_B:
; 					Display_Float((*(long *)value)*positionScale,0, decimalPlace);
	lds R2,_decimalPlace
	lds R3,_decimalPlace+1
	std y+3,R3
	std y+2,R2
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	movw R30,R10
	ldd R16,z+0
	ldd R17,z+1
	ldd R18,z+2
	ldd R19,z+3
	xcall long2fp
	ldi R24,<_positionScale
	ldi R25,>_positionScale
	st -y,R25
	st -y,R24
	xcall fpmule1
	xcall _Display_Float
	.dbline 183
; 					break;
	xjmp L14
L21:
	.dbline 187
; 						
; 				case COMMAND_7SEGMENT_SET_POSITION_SCALE:
; 				case COMMAND_7SEGMENT_SET_POSITION_SCALE_B:
; 					positionScale = *(float *)value;
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	ldd R4,z+2
	ldd R5,z+3
	sts _positionScale+1,R3
	sts _positionScale,R2
	sts _positionScale+2+1,R5
	sts _positionScale+2,R4
	.dbline 188
; 					break;
	xjmp L14
L22:
	.dbline 192
; 						
; 				case COMMAND_7SEGMENT_SET_DECIMAL_PLACE:
; 				case COMMAND_7SEGMENT_SET_DECIMAL_PLACE_B:
; 					decimalPlace = *(int *)value;
	movw R30,R10
	ldd R2,z+0
	ldd R3,z+1
	sts _decimalPlace+1,R3
	sts _decimalPlace,R2
	.dbline 193
; 					break;
	xjmp L14
L13:
	.dbline 196
; 				//If the command is not recognised, simply display it		
; 				default:
; 					Display_Int(temp[0], 0, HEX);
	ldi R24,16
	ldi R25,0
	std y+1,R25
	std y+0,R24
	clr R18
	clr R19
	ldd R16,y+4
	clr R17
	xcall _Display_Int
	.dbline 197
; 			}
L14:
	.dbline 198
; 		}
L10:
	.dbline 201
; 			  
; 		//Is it time we update our button values?
; 		if(TimeToUpdate())
	xcall _TimeToUpdate
	tst R16
	breq L25
X17:
	.dbline 202
; 		{
	.dbline 203
; 			updateButtons();
	xcall _updateButtons
	.dbline 204
; 			temp[0] = currentButtonValue;
	lds R2,_currentButtonValue
	std y+4,R2
	.dbline 206
; 			//Add button values
; 			TWI_Transceiver_Update_Data( temp, 1 );
	ldi R18,1
	movw R16,R28
	subi R16,252  ; offset = 4
	sbci R17,255
	xcall _TWI_Transceiver_Update_Data
	.dbline 207
; 		}
L25:
	.dbline 209
; 			 
; 	}
L8:
	.dbline 148
	xjmp L7
X18:
	.dbline -2
L6:
	.dbline 0 ; func end
	adiw R28,44
	xjmp pop_xgset300C
	.dbsym l i 5 c
	.dbsym r value 10 pV
	.dbsym l temp 4 A[40:40]c
	.dbend
	.dbfunc e TimeToUpdate _TimeToUpdate fc
	.even
_TimeToUpdate::
	.dbline -1
	.dbline 217
; }
; 
; /*!
;  * \brief This function checks a timer to see if it has counted down
;  * If it has it will restart the timer and return true
;  */
; unsigned char TimeToUpdate(void)
; {
	.dbline 218
; 	if(mseccountdown1 == 0)
	lds R2,_mseccountdown1
	lds R3,_mseccountdown1+1
	tst R2
	brne L28
	tst R3
	brne L28
X33:
	.dbline 219
; 	{
	.dbline 220
; 		mseccountdown1 = 10;
	ldi R24,10
	ldi R25,0
	sts _mseccountdown1+1,R25
	sts _mseccountdown1,R24
	.dbline 221
; 		return TRUE;
	ldi R16,1
	xjmp L27
L28:
	.dbline 223
; 	}
; 	return FALSE;				 		 
	clr R16
	.dbline -2
L27:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e watchdog_init _watchdog_init fV
	.even
_watchdog_init::
	.dbline -1
	.dbline 230
; }
; 
; 
; //Watchdog initialize
; // prescale: 2K
; void watchdog_init(void)
; {
	.dbline 231
;  WDR (); //this prevents a timeout on enabling
	wdr
	.dbline 236
;  
;  
;  //WDTCSR = (1<<WDIE) | (1<<WDCE) | (1<<WDE) | (7<<0);/* 30-Oct-2006 Umesh*/  
;  
;  WDTCSR |= (1<<WDCE);
	lds R24,96
	ori R24,16
	sts 96,R24
	.dbline 237
;  WDTCSR = 0x4F; //WATCHDOG ENABLED - dont forget to issue WDRs
	ldi R24,79
	sts 96,R24
	.dbline -2
L30:
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(rom, abs)
	.org 24
	jmp _wdt_isr
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\7SegmentDisplay.c
	.dbfunc e wdt_isr _wdt_isr fV
	.even
_wdt_isr::
	st -y,R0
	st -y,R1
	st -y,R2
	st -y,R3
	st -y,R4
	st -y,R5
	st -y,R6
	st -y,R7
	st -y,R8
	st -y,R9
	st -y,R16
	st -y,R17
	st -y,R18
	st -y,R19
	st -y,R24
	st -y,R25
	st -y,R26
	st -y,R27
	st -y,R30
	st -y,R31
	in R0,0x3f
	st -y,R0
	.dbline -1
	.dbline 242
; }
; 
; #pragma interrupt_handler wdt_isr:iv_WDT
; void wdt_isr(void)
; {
	.dbline 243
; 	uart0_puts ("\nWatchDog Timer");
	ldi R16,<L32
	ldi R17,>L32
	xcall _uart0_puts
	.dbline -2
L31:
	.dbline 0 ; func end
	ld R0,y+
	out 0x3f,R0
	ld R31,y+
	ld R30,y+
	ld R27,y+
	ld R26,y+
	ld R25,y+
	ld R24,y+
	ld R19,y+
	ld R18,y+
	ld R17,y+
	ld R16,y+
	ld R9,y+
	ld R8,y+
	ld R7,y+
	ld R6,y+
	ld R5,y+
	ld R4,y+
	ld R3,y+
	ld R2,y+
	ld R1,y+
	ld R0,y+
	reti
	.dbend
	.dbfunc e CheckEEPROMWritten _CheckEEPROMWritten fc
;      signature -> y+0
;              i -> R20
	.even
_CheckEEPROMWritten::
	st -y,R20
	sbiw R28,19
	.dbline -1
	.dbline 248
;  //watchdog timeout
; }
; 
; unsigned char CheckEEPROMWritten()
; {
	.dbline 252
;  	char signature[19];
; 	unsigned char i;
; 	
; 	signature[18] = 0;
	clr R2
	std y+18,R2
	.dbline 253
; 	for(i=0; i<18; i++)
	clr R20
	xjmp L38
L35:
	.dbline 254
;     {
	.dbline 255
;     	signature[i] = RTEEPROMread(i);//EEPROMread(i);
	mov R16,R20
	clr R17
	xcall _RTEEPROMread
	movw R24,R28
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R16
	.dbline 256
;     }
L36:
	.dbline 253
	inc R20
L38:
	.dbline 253
	cpi R20,18
	brlo L35
X34:
	.dbline 257
;     uart0_puts("\nRead PROM\n");
	ldi R16,<L39
	ldi R17,>L39
	xcall _uart0_puts
	.dbline 258
;     uart0_puts(&signature[0]);
	movw R16,R28
	xcall _uart0_puts
	.dbline 259
;     uart0_puts("\n--------\n");
	ldi R16,<L40
	ldi R17,>L40
	xcall _uart0_puts
	.dbline 260
; 	if(!strcmp(signature,"SOC Robotics V0.87")) return 1;
	ldi R18,<L43
	ldi R19,>L43
	movw R16,R28
	xcall _strcmp
	cpi R16,0
	cpc R16,R17
	brne L41
X35:
	.dbline 260
	ldi R16,1
	xjmp L33
L41:
	.dbline 261
; 	else return 0;
	clr R16
	.dbline -2
L33:
	.dbline 0 ; func end
	adiw R28,19
	ld R20,y+
	ret
	.dbsym l signature 0 A[19:19]c
	.dbsym r i 20 c
	.dbend
	.dbfunc e Init_EEPROM _Init_EEPROM fV
	.even
_Init_EEPROM::
	.dbline -1
	.dbline 265
; }
; 
; void Init_EEPROM()
; {
	.dbline 266
; 	WriteEEPROM(0,"SOC Robotics V0.87");
	ldi R18,<L43
	ldi R19,>L43
	clr R16
	clr R17
	xcall _WriteEEPROM
	.dbline -2
L44:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e LoadEEPROMSettings _LoadEEPROMSettings fV
	.even
_LoadEEPROMSettings::
	.dbline -1
	.dbline 272
; 	//EEPROMWrite(19,'d');   // Write calibration byte
; 	//EEPROMWrite(20,'3');      // Set baud rate to 38400
; }
; 
; void  LoadEEPROMSettings(void)
; {
	.dbline 275
; 	//  See if EEPROM setup values exist - if not write them 
; 	//  otherwise load settings
; 	if(CheckEEPROMWritten()==0)
	xcall _CheckEEPROMWritten
	tst R16
	brne L46
X36:
	.dbline 276
;     {
	.dbline 278
;     	
;         uart0_puts ("\nWrote Out Values\n");
	ldi R16,<L48
	ldi R17,>L48
	xcall _uart0_puts
	.dbline 280
;         // Write default values to EEPROM
; 		Init_EEPROM();
	xcall _Init_EEPROM
	.dbline 281
; 	}
	xjmp L51
L46:
	.dbline 283
; 	else
;     {
	.dbline 284
;     	uart0_puts ("\nReading Values\n");
	ldi R16,<L49
	ldi R17,>L49
	xcall _uart0_puts
	.dbline 288
; 	   // OSCCAL = EEPROMread(19);
; 		//SetNewBaudRate(EEPROMread(20));
; 		//puts("use eeprom settings\n\r");
;     }
L50:
	.dbline 290
;     
;     while(!RTEEPROMReady());
L51:
	.dbline 290
	xcall _RTEEPROMReady
	tst R16
	breq L50
X37:
	.dbline -2
L45:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e RTEEPROMwrite _RTEEPROMwrite fV
;      savedSREG -> R10
;       databyte -> R18
;       location -> R16,R17
	.even
_RTEEPROMwrite::
	st -y,R10
	.dbline -1
	.dbline 297
; }
; 
; // Function to initiate an EEPROM write
; // writes the specified data byte to the specified location
; // this will fail if the EEPROM is not ready!
; void RTEEPROMwrite(int location, unsigned char databyte)
; {
	.dbline 299
; 	unsigned char savedSREG;
; 	EEAR = location;								// set address
	out 0x22,R17
	out 0x21,R16
	.dbline 300
; 	EEDR = databyte;								// set data	
	out 0x20,R18
	.dbline 301
; 	savedSREG = SREG;								// keep setting so it can be restored
	in R10,0x3f
	.dbline 302
; 	CLI();													// disable interrupts
	cli
	.dbline 303
; 	EECR |= BIT(EEMWE);							// set "write enable" bit
	sbi 0x1f,2
	.dbline 304
; 	EECR |= BIT(EEWE);							// set "write" bit
	sbi 0x1f,1
	.dbline 305
; 	SREG = savedSREG;								// restore SREG
	out 0x3f,R10
	.dbline 306
; 	EEAR = 0;
	clr R2
	clr R3
	out 0x22,R3
	out 0x21,R2
	.dbline -2
L53:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r savedSREG 10 c
	.dbsym r databyte 18 c
	.dbsym r location 16 I
	.dbend
	.dbfunc e EEPROMWrite _EEPROMWrite fV
;       databyte -> R12
;       location -> R10,R11
	.even
_EEPROMWrite::
	xcall push_xgset003C
	mov R12,R18
	movw R10,R16
	.dbline -1
	.dbline 311
; }
; 
; // EEPROM writes take about 8ms - so poll until done
; void EEPROMWrite(int location, unsigned char databyte)
; {
L55:
	.dbline 312
;  	 while(!RTEEPROMReady())  ;
L56:
	.dbline 312
	xcall _RTEEPROMReady
	tst R16
	breq L55
X38:
	.dbline 313
;  	 RTEEPROMwrite(location,databyte);
	mov R18,R12
	movw R16,R10
	xcall _RTEEPROMwrite
L58:
	.dbline 314
;  	 while(!RTEEPROMReady())  ;
L59:
	.dbline 314
	xcall _RTEEPROMReady
	tst R16
	breq L58
X39:
	.dbline -2
L54:
	.dbline 0 ; func end
	xjmp pop_xgset003C
	.dbsym r databyte 12 c
	.dbsym r location 10 I
	.dbend
	.dbfunc e RTEEPROMread _RTEEPROMread fc
;       location -> R10,R11
	.even
_RTEEPROMread::
	st -y,R10
	st -y,R11
	movw R10,R16
	.dbline -1
	.dbline 318
; }
; 
; unsigned char RTEEPROMread(int location)
; {
L62:
	.dbline 319
; 	while(!RTEEPROMReady())  ;
L63:
	.dbline 319
	xcall _RTEEPROMReady
	tst R16
	breq L62
X40:
	.dbline 320
; 	EEAR = location;								// set address
	out 0x22,R11
	out 0x21,R10
	.dbline 321
; 	EECR |= BIT(EERE);							// set "read enable" bit
	sbi 0x1f,0
	.dbline 322
; 	EEAR = 0;
	clr R2
	clr R3
	out 0x22,R3
	out 0x21,R2
	.dbline 323
; 	return (EEDR);
	in R16,0x20
	.dbline -2
L61:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
	.dbsym r location 10 I
	.dbend
	.dbfunc e WriteEEPROM _WriteEEPROM fV
;              i -> R20,R21
;           strg -> R10,R11
;       location -> R12,R13
	.even
_WriteEEPROM::
	xcall push_xgset303C
	movw R10,R18
	movw R12,R16
	.dbline -1
	.dbline 328
; }
; 
; // Write a string of characters to EEPROM at specified start location
; void WriteEEPROM(int location, unsigned char *strg)
; {
	.dbline 331
; 	int i;
; 	 
; 	i = 0;
	clr R20
	clr R21
	xjmp L67
L66:
	.dbline 333
; 	while(strg[i] != 0x00)
; 	{
	.dbline 334
; 		EEPROMWrite(location+i,strg[i]);
	movw R30,R20
	add R30,R10
	adc R31,R11
	ldd R18,z+0
	movw R16,R12
	add R16,R20
	adc R17,R21
	xcall _EEPROMWrite
	.dbline 335
; 		i++;
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 336
; 	}
L67:
	.dbline 332
	movw R30,R20
	add R30,R10
	adc R31,R11
	ldd R2,z+0
	tst R2
	brne L66
X41:
	.dbline -2
L65:
	.dbline 0 ; func end
	xjmp pop_xgset303C
	.dbsym r i 20 I
	.dbsym r strg 10 pc
	.dbsym r location 12 I
	.dbend
	.dbfunc e RTEEPROMReady _RTEEPROMReady fc
	.even
_RTEEPROMReady::
	.dbline -1
	.dbline 342
; }
; 
; // function to test if the EEPROM is ready for a read or write operation
; // returns non zero if ready, zero if not ready 
; unsigned char RTEEPROMReady(void)
; {
	.dbline 343
; 	return !(EECR & 0x02);
	sbic 0x1f,1
	rjmp L70
X42:
	ldi R16,1
	ldi R17,0
	xjmp L71
L70:
	clr R16
	clr R17
L71:
	.dbline -2
L69:
	.dbline 0 ; func end
	ret
	.dbend
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\7SegmentDisplay.c
L49:
	.blkb 17
	.area idata
	.byte 10,'R,'e,'a,'d,'i,'n,'g,32,'V,'a,'l,'u,'e,'s,10
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\7SegmentDisplay.c
L48:
	.blkb 19
	.area idata
	.byte 10,'W,'r,'o,'t,'e,32,'O,'u,'t,32,'V,'a,'l,'u,'e
	.byte 's,10,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\7SegmentDisplay.c
L43:
	.blkb 19
	.area idata
	.byte 'S,'O,'C,32,'R,'o,'b,'o,'t,'i,'c,'s,32,'V,48,46
	.byte 56,55,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\7SegmentDisplay.c
L40:
	.blkb 11
	.area idata
	.byte 10,45,45,45,45,45,45,45,45,10,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\7SegmentDisplay.c
L39:
	.blkb 12
	.area idata
	.byte 10,'R,'e,'a,'d,32,'P,'R,'O,'M,10,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\7SegmentDisplay.c
L32:
	.blkb 16
	.area idata
	.byte 10,'W,'a,'t,'c,'h,'D,'o,'g,32,'T,'i,'m,'e,'r,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\7SegmentDisplay.c
L5:
	.blkb 18
	.area idata
	.byte 10,'S,'t,'a,'r,'t,32,'P,'e,'r,'i,'p,'h,'e,'r,'a
	.byte 'l,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\7SegmentDisplay\7SegmentDisplay.c
; }
; 
