#ifndef BOARD_H_
#define BOARD_H_

#define TRUE	1
#define FALSE	0
#define ON	1
#define OFF	0

#define TWI_ADDRESS 0x25

//TWI Commands
#define COMMAND_7SEGMENT_WRITE_INT 0x00
#define COMMAND_7SEGMENT_WRITE_HEX_INT 0x01
#define COMMAND_7SEGMENT_WRITE_BIN_INT 0x02
#define COMMAND_7SEGMENT_WRITE_FLOAT 0x03
#define COMMAND_7SEGMENT_WRITE_POSITION 0x04
#define COMMAND_7SEGMENT_SET_POSITION_SCALE 0x05
#define COMMAND_7SEGMENT_SET_DECIMAL_PLACE 0x06

// Alternate printable ASCII TWI Commands
#define COMMAND_7SEGMENT_WRITE_INT_B 	   'i'
#define COMMAND_7SEGMENT_WRITE_HEX_INT_B   'h'
#define COMMAND_7SEGMENT_WRITE_BIN_INT_B   'b'
#define COMMAND_7SEGMENT_WRITE_FLOAT_B 	   'f'
#define COMMAND_7SEGMENT_WRITE_POSITION_B  'p'
#define COMMAND_7SEGMENT_SET_POSITION_SCALE_B 's'
#define COMMAND_7SEGMENT_SET_DECIMAL_PLACE_B 'd'

#define DEFAULT_POSITION_SCALE 0.00015
#define DEFAULT_DECIMAL_PLACE 2
//Board Switches
#define SW2 1
#define SW3 0

extern unsigned char currentButtonValue;

void Buttons_Init(void);

unsigned char buttonState(unsigned char sw);
void updateButtons(void);


#endif /*BOARD_H_*/

