#include "Board.h"
#include <iom168v.h>
#include "Serial.h"

/* Initialize Serial Interface */
void uart0_init (void)
{
//InitUART( 129 ); /* Set the baudrate 9600 no parity no stop?*/                   
	UBRR0 = 129;//51;                  /* Set the baud rate */
	UCSR0B = ( (1<<RXEN0) | (1<<TXEN0) );  /* Enable UART receiver and transmitter */

}


unsigned char uart0_putc(unsigned char ch) 
{
	while ( !(UCSR0A & (1<<UDRE0)) )
		; 			                /* Wait for empty transmit buffer */
	UDR0 = ch; 			        /* Start transmittion */
	
	return ch;
}	

unsigned char uart0_putchar (unsigned char ch) {                      /* Write Character to Serial Port */

  if (ch == '\n')  {                            /* Check for LF */
    uart0_putc( '\r' );                         /* Output CR */
  }
  return uart0_putc( ch );                     /* Transmit Character */
}

void uart0_puts ( unsigned char* s )
{
	while ( *s ) uart0_putchar( *s++ );
}

unsigned char uart0_kbhit( void ) /* returns true if character in receive buffer */
{
	//if ( pUSART->US_CSR & AT91C_US_RXRDY) {
	//	return 1;
	//}
	//else {
		return 0;
	//}
}

unsigned char uart0_getc ( void )  /* Read Character from Serial Port */
{    
  	while ( !(UCSR0A & (1<<RXC0)) ) 	/* Wait for incomming data */
		;			                /* Return the data */
	return UDR0;
}