#include <iom168v.h>
#include "Timer.h"
#include "LED_Display.h"


unsigned int mseccountdown1, mseccountdown2,mseccountdown3;

void Init_Timer(void)
{
	mseccountdown1 = 0;
	mseccountdown2 = 0;
	mseccountdown3 = 0;
}

// Timer2 is called every 1msec - used to maintain four count down 
// software timers to control precise time delays in various routines
void Init_Timer0(void)
{ 
	 TCNT0 = 0;
	 // Set mode 2 - reset counter on compare match, clk/256
	 TCCR0A = (1<<WGM01);
	 TCCR0B = (1<<CS02);
	 // Reset count after 1 msec
	 OCR0A = 78;
	 // Enable compare match interrupt vector
	 TIMSK0 |= (1<<OCIE0A);
}

#pragma interrupt_handler TIMER0_Compare_Interrupt:iv_TIMER0_COMPA

//  *******************************************************
//                Interrupt handler
//  *******************************************************

//  Timer0 interrupts every msec - This routines decrements 
//  countdown timers - other routines can control timing to 
//  within 1 msec by monitoring these software timers
void  TIMER0_Compare_Interrupt(void)
{
	//PORTD^=(1<<0);//heart beat
 	if(mseccountdown1>0)  mseccountdown1--;
 	if(mseccountdown2>0)  mseccountdown2--;
	if(mseccountdown3>0)  mseccountdown3--;
	LED_Update();//refresh the 7 segement display
}