	.module LED8_Init.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Init.c
	.dbfunc e InitUART _InitUART fV
;              x -> R10
;       baudrate -> R16
	.even
_InitUART::
	st -y,R10
	.dbline -1
	.dbline 76
; /**************************************************************
; 
;    Program Title:  Led8 Controller
;    
;    Program Name:  LED8_Init.c		  Version: 0.85
;    
;    Author:  SS	  					  Date:  August 10, 2005
;    
;    Compiled with ImageCraft ICCAVR Standard V7.02
;    
;    This file contains routines that implement the basic initialization 
;    routines for the Wasp AVR Monitor.
;    
;    Copyright 2004-2006, SOC Robotics, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright 2004-2006, SOC Robotics, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC MACHINES, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-robotics.com
;  */
; 
; /*
;  * $Log: Wasp_Monitor.c,v $
;  * Revision 0.86  2006/02/07 16:40:20  SS
;  *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom48v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; //#include <stdio.h>
; #include "LED8_Uart.h"
; #include "LED8_Defines.h"
; #include "LED8_Extern.h"
; 
; //****************************************************************
; //****************************************************************
; // Initialization code
; //****************************************************************
; //****************************************************************
; 
; // Initialize UART
; void InitUART(unsigned char baudrate)
; {
	.dbline 80
; 	unsigned char x;
; 	
; 	// Set the baud rate
; 	UBRR0H = 0x00;
	clr R2
	sts 197,R2
	.dbline 81
; 	UBRR0L = baudrate; 
	sts 196,R16
	.dbline 83
; 	// Enable UART receiver and transmitter
; 	UCSR0B = BIT(RXCIE0)|BIT(UDRIE0)|BIT(RXEN0)|BIT(TXEN0); 
	ldi R24,184
	sts 193,R24
	.dbline 87
;     //  8 data bits, 2 stop bits
; //	UCSRC = (1<<URSEL)|(1<<USBS)|(3<<UCSZ0);
;     //  8 data bits, 1 stop bit
; 	UCSR0C = (1<<UMSEL01)|(3<<UCSZ01);
	ldi R24,140
	sts 194,R24
	.dbline 89
; 
; 	x = 0; // flush receive buffer
	clr R10
	.dbline 90
; 	rxcnt = x; // rx buffer empty
	sts _rxcnt,R10
	.dbline 91
; 	xoffsent = NO;
	sts _xoffsent,R2
	.dbline 92
; 	sendxoff = NO;
	sts _sendxoff,R2
	.dbline 93
; 	xonsent = NO;
	sts _xonsent,R2
	.dbline 94
; 	checkflag = NO;
	sts _checkflag,R2
	.dbline 95
; 	enablexonoff = YES; // turn serial driver xon/xoff flow control on
	ldi R24,1
	sts _enablexonoff,R24
	.dbline 96
; 	echoinchars = NO;   // echo all received characters
	sts _echoinchars,R2
	.dbline 97
; 	UART_RxTail = x;
	sts _UART_RxTail,R10
	.dbline 98
; 	UART_RxHead = x;
	sts _UART_RxHead,R10
	.dbline 99
; 	UART_TxTail = x;
	sts _UART_TxTail,R10
	.dbline 100
; 	UART_TxHead = x;
	sts _UART_TxHead,R10
	.dbline 101
; 	dataoverrun = NO;
	sts _dataoverrun,R2
	.dbline 102
; 	frameerror = NO;
	sts _frameerror,R2
	.dbline 103
; 	xoncnt = 0;
	clr R3
	sts _xoncnt+1,R3
	sts _xoncnt,R2
	.dbline 104
; 	xoffcnt = 0;
	sts _xoffcnt+1,R3
	sts _xoffcnt,R2
	.dbline -2
L1:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r x 10 c
	.dbsym r baudrate 16 c
	.dbend
	.dbfunc e InitADC _InitADC fV
	.even
_InitADC::
	.dbline -1
	.dbline 110
; }
; 
; //  Setup the Analog to Digital converter
; //  TBD - convert to background interrupt process
; void InitADC(void)
; {
	.dbline 111
; 	DDRB = 0x00;  // All inputs
	clr R2
	out 0x4,R2
	.dbline -2
L2:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e InitRealTimeClock _InitRealTimeClock fV
	.even
_InitRealTimeClock::
	.dbline -1
	.dbline 120
; 		   		  // Setup Analog TDB
; }
; 
; //  Start the real time clock 
; //  Clocked by external 32.768KHz watch crystal
; //  Set prescalar to 0, set to interrupt using compare match 
; //  set to 128 (4msec interrupt rate).  
; void InitRealTimeClock(void)
; {  
	.dbline 122
;     // Software counters - approximately 4msec resolution
; 	rtccountdown1 = 0;  
	clr R2
	clr R3
	sts _rtccountdown1+1,R3
	sts _rtccountdown1,R2
	.dbline 123
; 	rtccountdown2 = 0;
	sts _rtccountdown2+1,R3
	sts _rtccountdown2,R2
	.dbline 124
; 	rtccountdown3 = 0;
	sts _rtccountdown3+1,R3
	sts _rtccountdown3,R2
	.dbline 125
; 	rtccountdown4 = 0;
	sts _rtccountdown4+1,R3
	sts _rtccountdown4,R2
	.dbline 127
; 	
;  	TCNT2 = 0;
	sts 178,R2
	.dbline 129
;  	// Select external real time clock oscillator
; 	ASSR = (1<<AS2);
	ldi R24,32
	sts 182,R24
	.dbline 131
; 	// Set match interrupt to 4msec
; 	OCR2A = 127;
	ldi R24,127
	sts 179,R24
	.dbline 133
; 	// Reload counter on match interrupt - pre-scalar set to 0
; 	TCCR2A = (1<<WGM21)|(1<<CS20);   
	ldi R24,3
	sts 176,R24
	.dbline 135
;     // setup interrupts for real time clock
;     TIMSK2 |= (1<<OCIE2A);
	lds R24,112
	ori R24,2
	sts 112,R24
	.dbline -2
L3:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Init_Timer0 _Init_Timer0 fV
	.even
_Init_Timer0::
	.dbline -1
	.dbline 141
; }
; 
; // Timer2 is called every 1msec - used to maintain four count down 
; // software timers to control precise time delays in various routines
; void Init_Timer0(void)
; {
	.dbline 142
;  	 mseccountdown1 = 0;
	clr R2
	clr R3
	sts _mseccountdown1+1,R3
	sts _mseccountdown1,R2
	.dbline 143
; 	 mseccountdown2 = 0;
	sts _mseccountdown2+1,R3
	sts _mseccountdown2,R2
	.dbline 144
; 	 mseccountdown3 = 0;
	sts _mseccountdown3+1,R3
	sts _mseccountdown3,R2
	.dbline 146
; 	 
; 	 ledindex = 0;
	sts _ledindex,R2
	.dbline 150
; 	 
; 	 //PRR = (PRR&0xDF);
; 	 
; 	 TCNT0 = 0;
	out 0x26,R2
	.dbline 152
; 	 // Set mode 2 - reset counter on compare match, clk/8
; 	 TCCR0B = ((1<<CS01)|(1<<CS00));
	ldi R24,3
	out 0x25,R24
	.dbline 153
; 	 TCCR0A = (1<<WGM01);
	ldi R24,2
	out 0x24,R24
	.dbline 155
; 	 // Reset count after 1 msec
; 	 OCR0A = 252;
	ldi R24,252
	out 0x27,R24
	.dbline 157
; 	 // Enable compare match interrupt vector
; 	 TIMSK0 |= (1<<OCIE0A);
	lds R24,110
	ori R24,2
	sts 110,R24
	.dbline -2
L4:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e InitWatchdog _InitWatchdog fV
	.even
_InitWatchdog::
	.dbline -1
	.dbline 162
; }
; 
; // Setup watch dog timer - TBD
; void InitWatchdog(void)
; {
	.dbline -2
L5:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Init_SPI_Master _Init_SPI_Master fV
	.even
_Init_SPI_Master::
	.dbline -1
	.dbline 166
; }
; 
; void Init_SPI_Master(void)
; {
	.dbline 168
;     // Set MOSI and SCK output, all others input
; 	DDRB = (1<<PB5)|(1<<PB7)|(1<<PB4);
	ldi R24,176
	out 0x4,R24
	.dbline 169
; 	PORTB |= 0xA0;  // Set bits MOSI & SCK
	in R24,0x5
	ori R24,160
	out 0x5,R24
	.dbline 172
; 
; 	//  Make Flash Chip select PC4 output and set high
; 	DDRC |= 0x10; 
	sbi 0x7,4
	.dbline 173
; 	PORTC |= 0x10;  
	sbi 0x8,4
	.dbline 177
; 	
; 	// Enable SPI, Master, set clock rate fck
; 	//    Select SPI Mode 3 - CPOL=1, CPHA=1
; 	SPCR = (1<<SPE)|(1<<MSTR)|(1<<CPOL)|(1<<CPHA)|(1<<SPR0);
	ldi R24,93
	out 0x2c,R24
	.dbline -2
L6:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Init_AVR _Init_AVR fV
	.even
_Init_AVR::
	.dbline -1
	.dbline 185
; //	SPCR = 0x91;
; }
; 
; //************************************************************
; //  Initialize the AVR - Set LED start conditions
; //************************************************************
; void Init_AVR(void)
; {
	.dbline 189
; 	// Setup Port D
; 	//   RxD - PD0, TxD - PD1
; 	//   LED1-PD2, LED2-PD3, LED3-PD4, LED4-PD5, LED5-PD6, LED6-PD7
; 	DDRD = 0xFC;
	ldi R24,252
	out 0xa,R24
	.dbline 190
; 	PORTD = 0x00;  // Turn all LED master power enables off
	clr R2
	out 0xb,R2
	.dbline 195
; 	
; 	// Setup Port B
; 	//   LED7-PB6, LED8-PB7, DP-PB2,  PC6-g
; 	//   New LED8 - LED7-PB5, LED8-PB4, DP-PB2,  PB1-e, PB3-f, PB0-g
; 	DDRB = 0x3F;
	ldi R24,63
	out 0x4,R24
	.dbline 196
; 	PORTB = 0x00;  // Turn LED power enables off
	out 0x5,R2
	.dbline 201
; 	
; 	// Setup Port C - LED Character control
; 	//   Bit PC0 - a, PC1-b, PC2-c, PC3-d, PC4-SDA, PC5-SCL
; 	//   Bit PC7 - Reset
; 	DDRC = 0x7F;
	ldi R24,127
	out 0x7,R24
	.dbline 202
; 	PORTC = 0x7F;  // turn all LED segments off
	out 0x8,R24
	.dbline 213
; 	
; 	//   Setup SPI - SPI default inactive in this release
; //    Init_SPI_Master();
; 	
; 	//    Turn on real time clock on PC7,6 Timer/Counter 2
; //	InitRealTimeClock();
; 	
; 	// Setup Timer 0 to interrupt a 1msec rate - this interrupt
; 	// controls four software delay timers used by various 
; 	// routines
; 	Init_Timer0();
	xcall _Init_Timer0
	.dbline -2
L7:
	.dbline 0 ; func end
	ret
	.dbend
; 	
; 	//    Setup 2-Wire Interface
; 	//Init_TWI_Master();   // SCL freq = sclk/(16+2*TWBR)*4*TWPS
; 
; 	// Watchdog timer setup
; //	InitWatchdog();
; 	
; 	// Initialize UART - Interrupt
; 	// Set the baudrate to 9,600 bps using an 8MHz clock
; //	InitUART(BAUDRATE9600); 
; 					
; }
