	.module LED8_SPI_Flash.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\Stephen\Desktop\LED8CO~1\LED8_SPI_Flash.c
	.dbfunc e FlashChipSelect _FlashChipSelect fV
;           mode -> R20
	.even
_FlashChipSelect::
	rcall push_gset1
	mov R20,R16
	.dbline -1
	.dbline 83
; /**************************************************************
; 
;    Program Title:  Led8 Controller
;    
;    Program Name:  LED8_SPI_Flash.c	Version: 0.85
;    
;    Author:  SS	  					Date:  August 10, 2005
;    
;    Compiled with ImageCraft ICCAVR Standard V7.02
;    
;    The AVR SPI lines are connected to two serial flash devices U2 
;    and U5. If the AVR needs to communicate with the Serial 
;    Flash devices the Blackfin must relinquish control of the SPI 
;    lines. 
;    
;    Serial flash devices compatible with the P1 are the AT45DB041
;    (512kx8), AT45DB081 (1Mx8), AT45DB161 (2Mx8), AT45DB321 (4Mx8)
;    or AT45DB642 (8Mx8).
;    
;    The Serial Flash chips are page oriented with 2 SRAM buffers of 264,
;    528 or 1024 bytes each.  The AVR programs the serial flash devices by 
;    loading files via the serial line (in IntelHex32 format) into the RAM 
;    buffers before transfer to the appropriate page.  Page erase/programming 
;    requires about 30msec per page. The routines in this file perform these 
;    functions.  The host terminal program must support XON/XOFF flow control.
;    
;    Copyright 2004-2006, SOC Robotics, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright 2004-2006, SOC Robotics, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC MACHINES, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-robotics.com
;  */
; 
; /*
;  * $Log: Wasp_Monitor.c,v $
;  * Revision 0.86  2006/02/07 16:40:20  SS
;  *    2-wire interface, 8MHz clock, Serial Flash Writer, XON/XOFF
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom48v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; //#include <stdio.h>
; #include "LED8_Uart.h"
; #include "LED8_Defines.h"
; #include "LED8_Extern.h"
; 
; // Set Serial Flash chip select state
; void FlashChipSelect(unsigned char mode)
; {
	.dbline 84
;      shortdelay(2);
	ldi R16,2
	ldi R17,0
	rcall _shortdelay
	.dbline 85
; 	 if(mode==LOW) PORTB &= 0xEF; 
	cpi R20,2
	brne L2
	.dbline 85
	in R24,0x5
	andi R24,239
	out 0x5,R24
	rjmp L3
L2:
	.dbline 86
; 	 else PORTB |= 0x10;  
	sbi 0x5,4
L3:
	.dbline 87
;      shortdelay(2);
	ldi R16,2
	ldi R17,0
	rcall _shortdelay
	.dbline -2
L1:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r mode 20 c
	.dbend
	.dbfunc e ConvertFlashAddress _ConvertFlashAddress fV
;     superpages -> R10,R11
;      bytestart -> R20,R21
;          pages -> R22,R23
;        address -> R20,R21
	.even
_ConvertFlashAddress::
	rcall push_gset3
	movw R20,R16
	.dbline -1
	.dbline 93
; }
; 
; //  SPI Flash device address construction function
; //  Read address consists of 4 zero bits+11 page bits+9 byte start bits
; void ConvertFlashAddress(unsigned int address)
; {
	.dbline 96
;  	int pages,bytestart,superpages;
; 	
; 	pages = address/flashpagesize0;
	lds R18,_flashpagesize0
	lds R19,_flashpagesize0+1
	movw R16,R20
	rcall div16u
	movw R22,R16
	.dbline 97
; 	superpages = pages/7;
	ldi R18,7
	ldi R19,0
	rcall div16s
	movw R10,R16
	.dbline 98
; 	bytestart = address - pages*flashpagesize0;
	lds R18,_flashpagesize0
	lds R19,_flashpagesize0+1
	movw R16,R22
	rcall empy16s
	sub R20,R16
	sbc R21,R17
	.dbline 99
;     FlashAddress[0] = superpages;
	sts _FlashAddress,R10
	.dbline 100
; 	FlashAddress[1] = ((pages&0x00ff)<<1) + (bytestart>>8);
	movw R2,R20
	mov R2,R3
	clr R3
	sbrc R2,7
	com R3
	movw R24,R22
	andi R25,0
	lsl R24
	rol R25
	add R24,R2
	adc R25,R3
	sts _FlashAddress+1,R24
	.dbline 101
; 	FlashAddress[2] = bytestart & 0x00FF;
	movw R24,R20
	andi R25,0
	sts _FlashAddress+2,R24
	.dbline -2
L4:
	rcall pop_gset3
	.dbline 0 ; func end
	ret
	.dbsym r superpages 10 I
	.dbsym r bytestart 20 I
	.dbsym r pages 22 I
	.dbsym r address 20 i
	.dbend
	.dbfunc e SPI_SerialFlashStatus _SPI_SerialFlashStatus fc
;      instatus2 -> <dead>
;       instatus -> R20
	.even
_SPI_SerialFlashStatus::
	rcall push_gset1
	.dbline -1
	.dbline 106
; }
; 
; //  Get serial flash chip status
; unsigned char SPI_SerialFlashStatus(void)
; {
	.dbline 110
;  	 unsigned char instatus,instatus2;
; 	 
; 	 //  Set PB4 - Flash CS
; 	 FlashChipSelect(LOW);
	ldi R16,2
	rcall _FlashChipSelect
	.dbline 113
; 
; 	 // Send read status command
;  	 SPI_MasterTransmit(SF_READ_STATUS);
	ldi R16,215
	rcall _SPI_MasterTransmit
	.dbline 115
; 
; 	 instatus = SPI_MasterReceive();
	rcall _SPI_MasterReceive
	.dbline 116
; 	 instatus = SPI_MasterReceive();
	rcall _SPI_MasterReceive
	mov R20,R16
	.dbline 119
; 	 
; 	 // Set PC4 or PD2 high - deselect Flash chip
; 	 FlashChipSelect(HIGH);
	ldi R16,1
	rcall _FlashChipSelect
	.dbline 121
; 	 
; 	 return instatus;
	mov R16,R20
	.dbline -2
L7:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym l instatus2 1 c
	.dbsym r instatus 20 c
	.dbend
	.dbfunc e SPI_StartReadFlashPage _SPI_StartReadFlashPage fV
;              i -> R20,R21
;        address -> R20,R21
	.even
_SPI_StartReadFlashPage::
	rcall push_gset1
	movw R20,R16
	.dbline -1
	.dbline 127
; }
; 
; //  SPI Flash continuous read command for AT45DB041B
; //  The AT45DB041B has 2048 264byte pages
; void SPI_StartReadFlashPage(unsigned int address)
; {
	.dbline 131
;  	 int i;
; 	 
; 	 // Send Continuous read command
;  	 SPI_MasterTransmit(SF_READ_CONT);
	ldi R16,232
	rcall _SPI_MasterTransmit
	.dbline 134
; 	 
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(address);
	movw R16,R20
	rcall _ConvertFlashAddress
	.dbline 135
	clr R20
	clr R21
L9:
	.dbline 135
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	movw R30,R20
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	rcall _SPI_MasterTransmit
L10:
	.dbline 135
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 135
	cpi R20,3
	ldi R30,0
	cpc R21,R30
	brlt L9
	.dbline 138
	clr R20
	clr R21
L13:
	.dbline 138
	clr R16
	rcall _SPI_MasterTransmit
L14:
	.dbline 138
; 	 
; 	 //  32 dummy bits
; 	 for(i=0; i<4; i++)  SPI_MasterTransmit(0x00);
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 138
	cpi R20,4
	ldi R30,0
	cpc R21,R30
	brlt L13
	.dbline -2
L8:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r i 20 I
	.dbsym r address 20 i
	.dbend
	.dbfunc e SPI_ReadFlashBuffer _SPI_ReadFlashBuffer fV
;              i -> R20,R21
;   buffernumber -> R22,R23
;        address -> R20,R21
	.even
_SPI_ReadFlashBuffer::
	rcall push_gset2
	movw R22,R18
	movw R20,R16
	.dbline -1
	.dbline 143
; }
; 
; //  SPI Flash Buffer Read command for AT45DB041B
; void SPI_ReadFlashBuffer(unsigned int address,unsigned int buffernumber)
; {
	.dbline 147
;  	 int i;
; 	 
; 	 // Send buffer read command
; 	 if(buffernumber==1) SPI_MasterTransmit(SF_READ_BUFFER1);
	cpi R22,1
	ldi R30,0
	cpc R23,R30
	brne L18
	.dbline 147
	ldi R16,84
	rcall _SPI_MasterTransmit
	rjmp L19
L18:
	.dbline 148
; 	 else SPI_MasterTransmit(SF_READ_BUFFER2);
	ldi R16,86
	rcall _SPI_MasterTransmit
L19:
	.dbline 151
; 	 
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(address);
	movw R16,R20
	rcall _ConvertFlashAddress
	.dbline 152
; 	 FlashAddress[0] = 0x00;
	clr R2
	sts _FlashAddress,R2
	.dbline 153
	clr R20
	clr R21
L20:
	.dbline 153
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	movw R30,R20
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	rcall _SPI_MasterTransmit
L21:
	.dbline 153
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 153
	cpi R20,3
	ldi R30,0
	cpc R21,R30
	brlt L20
	.dbline 156
; 	 
; 	 //  8 dummy bits
; 	 SPI_MasterTransmit(0x00);
	clr R16
	rcall _SPI_MasterTransmit
	.dbline -2
L17:
	rcall pop_gset2
	.dbline 0 ; func end
	ret
	.dbsym r i 20 I
	.dbsym r buffernumber 22 i
	.dbsym r address 20 i
	.dbend
	.dbfunc e DisplaySerialFlash _DisplaySerialFlash fV
;       numlines -> y+0
; bytesonlastline -> y+5
;        linecnt -> y+3
;     newaddress -> R22,R23
;      tempvalue -> R20
;       asciicnt -> y+2
;       crcvalue -> R14
;           byte -> R10
;              i -> R12
;       readmode -> y+20
;       numbytes -> R20,R21
;        address -> y+16
	.even
_DisplaySerialFlash::
	rcall push_arg4
	rcall push_gset5
	movw R20,R18
	sbiw R28,6
	.dbline -1
	.dbline 163
; }
; 
; 
; //  Display P1 Blackfin Flash memory
; //    Blackfin must be reset
; void DisplaySerialFlash(unsigned int address,unsigned int numbytes,char readmode)
; {
	.dbline 168
;  	 unsigned char i,byte,bytesonlastline,asciicnt,crcvalue,tempvalue;
; 	 int linecnt,numlines,newaddress;
; 
; 	 //  Set PC4 low - Flash CS
; 	 FlashChipSelect(LOW);  
	ldi R16,2
	rcall _FlashChipSelect
	.dbline 170
; 
; 	 if(readmode==READCONTINUOUS) SPI_StartReadFlashPage(address);
	ldd R24,y+20
	cpi R24,1
	brne L25
	.dbline 170
	ldd R16,y+16
	ldd R17,y+17
	rcall _SPI_StartReadFlashPage
	rjmp L26
L25:
	.dbline 171
; 	 else if(readmode==READBUFFER) SPI_ReadFlashBuffer(address,1);
	ldd R24,y+20
	cpi R24,2
	brne L27
	.dbline 171
	ldi R18,1
	ldi R19,0
	ldd R16,y+16
	ldd R17,y+17
	rcall _SPI_ReadFlashBuffer
L27:
L26:
	.dbline 173
; //	 puts("Send Continuous Read command\n\r");
; 	 linecnt = asciicnt = 0;
	clr R0
	std y+2,R0
	clr R2
	clr R3
	std y+4,R3
	std y+3,R2
	.dbline 174
; 	 bytesonline = 16;	 
	ldi R24,16
	ldi R25,0
	sts _bytesonline+1,R25
	sts _bytesonline,R24
	.dbline 175
; 	 numlines = numbytes/bytesonline;
	movw R18,R24
	movw R16,R20
	rcall div16u
	std y+1,R17
	std y+0,R16
	.dbline 176
; 	 bytesonlastline = numbytes - numlines*bytesonline;
	lds R18,_bytesonline
	lds R19,_bytesonline+1
	rcall empy16s
	movw R2,R20
	sub R2,R16
	sbc R3,R17
	std y+5,R2
	rjmp L30
L29:
	.dbline 177
; 	 while(linecnt<numlines) {
	.dbline 178
; 	 	 crcvalue = 0;
	clr R14
	.dbline 179
; 	     putchar(':');
	ldi R16,58
	ldi R17,0
	rcall _putchar
	.dbline 181
; 		 //  Output bytes on line
; 		 PrintHex(bytesonline);
	lds R16,_bytesonline
	rcall _PrintHex
	.dbline 182
; 		 crcvalue += bytesonline;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R14
	clr R5
	add R4,R2
	adc R5,R3
	mov R14,R4
	.dbline 184
; 	     //  Output hex start address
; 		 newaddress = address+linecnt*16;
	ldi R16,16
	ldi R17,0
	ldd R18,y+3
	ldd R19,y+4
	rcall empy16s
	ldd R22,y+16
	ldd R23,y+17
	add R22,R16
	adc R23,R17
	.dbline 185
; 	     PrintWordHex(newaddress);
	movw R16,R22
	rcall _PrintWordHex
	.dbline 186
; 		 tempvalue = (newaddress&0xff00)>>8;
	movw R20,R22
	andi R20,0
	mov R20,R21
	clr R21
	.dbline 187
; 		 crcvalue += tempvalue;
	add R14,R20
	.dbline 188
; 		 tempvalue = newaddress&0x00ff;
	mov R20,R22
	andi R21,0
	.dbline 189
; 		 crcvalue += tempvalue;
	add R14,R20
	.dbline 191
; 		 //  Output 00
; 		 puts("00");
	ldi R16,<L32
	ldi R17,>L32
	rcall _puts
	.dbline 193
	clr R12
	rjmp L36
L33:
	.dbline 193
	.dbline 194
	rcall _SPI_MasterReceive
	mov R10,R16
	.dbline 195
	ldd R2,y+2
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	std y+2,R24
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R2
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R10
	.dbline 196
	add R14,R16
	.dbline 197
	rcall _PrintHex
	.dbline 198
L34:
	.dbline 193
	inc R12
L36:
	.dbline 193
; 		 //  Output data
; 	     for(i=0; i<bytesonline; i++) {
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R12
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L33
	.dbline 199
; 	         byte = SPI_MasterReceive();
; 			 ascii[asciicnt++] = byte;
; 			 crcvalue += byte;
; 	         PrintHex(byte);
; 	         }
; 		 linecnt++;
	ldd R24,y+3
	ldd R25,y+4
	adiw R24,1
	std y+4,R25
	std y+3,R24
	.dbline 200
; 		 asciicnt = 0;
	clr R0
	std y+2,R0
	.dbline 202
; 		 // Output CRC
; 	     PrintHex((~crcvalue)+0x01);
	mov R16,R14
	com R16
	subi R16,255    ; addi 1
	rcall _PrintHex
	.dbline 203
; 	     puts("  ");
	ldi R16,<L37
	ldi R17,>L37
	rcall _puts
	.dbline 204
	clr R12
	rjmp L41
L38:
	.dbline 204
; 		 for(i=0; i<bytesonline; i++) {
	.dbline 205
; 		     if(ascii[i]>0x1F&&ascii[i]<0x80)  putchar(ascii[i]);
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R12
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	clr R3
	ldi R24,31
	cp R24,R2
	brsh L42
	mov R24,R2
	cpi R24,128
	brsh L42
	.dbline 205
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R12
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	clr R17
	rcall _putchar
	rjmp L43
L42:
	.dbline 206
; 			 else putchar('.');
	ldi R16,46
	ldi R17,0
	rcall _putchar
L43:
	.dbline 207
L39:
	.dbline 204
	inc R12
L41:
	.dbline 204
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R12
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L38
	.dbline 208
	rcall _putCRLF
	.dbline 209
L30:
	.dbline 177
	ldd R2,y+0
	ldd R3,y+1
	ldd R0,y+3
	ldd R1,y+4
	cp R0,R2
	cpc R1,R3
	brge X0
	rjmp L29
X0:
	.dbline 210
; 			 }
; 	     putCRLF();  
; 		 }
; 	 if(bytesonlastline) {
	ldd R2,y+5
	tst R2
	brne X1
	rjmp L44
X1:
	.dbline 210
	.dbline 211
; 	     crcvalue = 0;
	clr R14
	.dbline 212
; 	     putchar(':');
	ldi R16,58
	ldi R17,0
	rcall _putchar
	.dbline 214
; 		 //  Output bytes on line
; 		 PrintHex(bytesonline);
	lds R16,_bytesonline
	rcall _PrintHex
	.dbline 215
; 		 crcvalue += bytesonline;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R14
	clr R5
	add R4,R2
	adc R5,R3
	mov R14,R4
	.dbline 217
; 	     //  Output hex start address
; 		 newaddress = address+linecnt*16;
	ldi R16,16
	ldi R17,0
	ldd R18,y+3
	ldd R19,y+4
	rcall empy16s
	ldd R22,y+16
	ldd R23,y+17
	add R22,R16
	adc R23,R17
	.dbline 218
; 	     PrintWordHex(newaddress);
	movw R16,R22
	rcall _PrintWordHex
	.dbline 219
; 		 tempvalue = (newaddress&0xff00)>>8;
	movw R20,R22
	andi R20,0
	mov R20,R21
	clr R21
	.dbline 220
; 		 crcvalue += tempvalue;
	add R14,R20
	.dbline 221
; 		 tempvalue = newaddress&0x00ff;
	mov R20,R22
	andi R21,0
	.dbline 222
; 		 crcvalue += tempvalue;
	add R14,R20
	.dbline 224
; 		 //  Output 00
; 		 puts("00");
	ldi R16,<L32
	ldi R17,>L32
	rcall _puts
	.dbline 226
	clr R12
	rjmp L49
L46:
	.dbline 226
	.dbline 227
	rcall _SPI_MasterReceive
	mov R10,R16
	.dbline 228
	ldd R2,y+2
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	std y+2,R24
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R2
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R10
	.dbline 229
	add R14,R16
	.dbline 230
	rcall _PrintHex
	.dbline 231
L47:
	.dbline 226
	inc R12
L49:
	.dbline 226
; 		 //  Output data
; 	     for(i=0; i<bytesonlastline; i++) {
	ldd R0,y+5
	cp R12,R0
	brlo L46
	.dbline 233
; 	         byte = SPI_MasterReceive();
; 			 ascii[asciicnt++] = byte;
; 			 crcvalue += byte;
; 	         PrintHex(byte);
; 	         }
; 		 // Output CRC
; 	     PrintHex((~crcvalue)+0x01);
	mov R16,R14
	com R16
	subi R16,255    ; addi 1
	rcall _PrintHex
	.dbline 234
; 	     puts("  ");
	ldi R16,<L37
	ldi R17,>L37
	rcall _puts
	.dbline 235
	clr R12
	rjmp L53
L50:
	.dbline 235
; 		 for(i=0; i<bytesonlastline; i++) {
	.dbline 236
; 		     if(ascii[i]>0x1F&&ascii[i]<0x80)  putchar(ascii[i]);
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R12
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	clr R3
	ldi R24,31
	cp R24,R2
	brsh L54
	mov R24,R2
	cpi R24,128
	brsh L54
	.dbline 236
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R12
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	clr R17
	rcall _putchar
	rjmp L55
L54:
	.dbline 237
; 			 else putchar('.');
	ldi R16,46
	ldi R17,0
	rcall _putchar
L55:
	.dbline 238
L51:
	.dbline 235
	inc R12
L53:
	.dbline 235
	ldd R0,y+5
	cp R12,R0
	brlo L50
	.dbline 239
	rcall _putCRLF
	.dbline 242
	ldi R16,1
	rcall _FlashChipSelect
	.dbline 243
L44:
	.dbline -2
L24:
	adiw R28,6
	rcall pop_gset5
	adiw R28,4
	.dbline 0 ; func end
	ret
	.dbsym l numlines 0 I
	.dbsym l bytesonlastline 5 c
	.dbsym l linecnt 3 I
	.dbsym r newaddress 22 I
	.dbsym r tempvalue 20 c
	.dbsym l asciicnt 2 c
	.dbsym r crcvalue 14 c
	.dbsym r byte 10 c
	.dbsym r i 12 c
	.dbsym l readmode 20 c
	.dbsym r numbytes 20 i
	.dbsym l address 16 i
	.dbend
	.dbfunc e ProgramBuffertoPageErase _ProgramBuffertoPageErase fV
;              i -> R20
;       bufferid -> R20
	.even
_ProgramBuffertoPageErase::
	rcall push_gset1
	mov R20,R16
	.dbline -1
	.dbline 249
; 			 }
; 		 putCRLF();
; 		 
; 		 // Set PC4 high - deselect Flash chip
; 		 FlashChipSelect(HIGH);  
; 		 }
; }
; 
; // Transfer buffer n to flash memory with built-in erase
; //  This operation takes about 20msec max
; void  ProgramBuffertoPageErase(unsigned char bufferid)
; {
	.dbline 253
;      unsigned char i;
; 	 
; 	 // Serial Flash CS low
; 	 FlashChipSelect(LOW);    
	ldi R16,2
	rcall _FlashChipSelect
	.dbline 256
; 	 
; 	 //  Buffer write
; 	 if(bufferid==1) SPI_MasterTransmit(SF_BUF1_TO_FLASH_ERASE);
	cpi R20,1
	brne L57
	.dbline 256
	ldi R16,131
	rcall _SPI_MasterTransmit
	rjmp L58
L57:
	.dbline 257
; 	 else SPI_MasterTransmit(SF_BUF2_TO_FLASH_ERASE);
	ldi R16,134
	rcall _SPI_MasterTransmit
L58:
	.dbline 260
; 	 
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(inteladdress);
	lds R16,_inteladdress
	lds R17,_inteladdress+1
	rcall _ConvertFlashAddress
	.dbline 262
	clr R20
	rjmp L62
L59:
	.dbline 262
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	rcall _SPI_MasterTransmit
L60:
	.dbline 262
	inc R20
L62:
	.dbline 262
; //	 FlashAddress[0] = 0x00;
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	cpi R20,3
	brlo L59
	.dbline 265
; 	 
; 	 // Serial Flash CS high - start erase
; 	 FlashChipSelect(HIGH);   	 
	ldi R16,1
	rcall _FlashChipSelect
	.dbline -2
L56:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r i 20 c
	.dbsym r bufferid 20 c
	.dbend
	.dbfunc e EraseFlashPage _EraseFlashPage fV
;              i -> R20
	.even
_EraseFlashPage::
	rcall push_gset1
	.dbline -1
	.dbline 270
; }
; 
; // Maximum erase time is 20msec
; void  EraseFlashPage()
; {
	.dbline 274
;      unsigned char i;
; 	 
; 	 // Serial Flash CS low
; 	 FlashChipSelect(LOW);    
	ldi R16,2
	rcall _FlashChipSelect
	.dbline 277
; 	 
; 	 //  Buffer write
; 	 SPI_MasterTransmit(SF_PAGE_ERASE);
	ldi R16,129
	rcall _SPI_MasterTransmit
	.dbline 280
; 	 
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(inteladdress);
	lds R16,_inteladdress
	lds R17,_inteladdress+1
	rcall _ConvertFlashAddress
	.dbline 282
	clr R20
	rjmp L67
L64:
	.dbline 282
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	rcall _SPI_MasterTransmit
L65:
	.dbline 282
	inc R20
L67:
	.dbline 282
; //	 FlashAddress[0] = 0x00;
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	cpi R20,3
	brlo L64
	.dbline 285
; 	 
; 	 // Serial Flash CS high - start erase
; 	 FlashChipSelect(HIGH);   	 
	ldi R16,1
	rcall _FlashChipSelect
	.dbline -2
L63:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r i 20 c
	.dbend
	.dbfunc e ProgramFlashBuffer _ProgramFlashBuffer fV
;              i -> R20
;       bufferid -> R20
	.even
_ProgramFlashBuffer::
	rcall push_gset1
	mov R20,R16
	.dbline -1
	.dbline 290
; }
; 
; //  Load data into flash chip RAM buffer
; void ProgramFlashBuffer(unsigned char bufferid)
; {
	.dbline 294
;      unsigned char i;
; 	 
; 	 // Serial Flash CS low
; 	 FlashChipSelect(LOW);    
	ldi R16,2
	rcall _FlashChipSelect
	.dbline 297
; 	 
; 	 //  Buffer write
; 	 if(bufferid==1)  SPI_MasterTransmit(SF_WRITE_BUFFER1);
	cpi R20,1
	brne L69
	.dbline 297
	ldi R16,132
	rcall _SPI_MasterTransmit
	rjmp L70
L69:
	.dbline 298
; 	 else  SPI_MasterTransmit(SF_WRITE_BUFFER2);
	ldi R16,135
	rcall _SPI_MasterTransmit
L70:
	.dbline 301
; 	 
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(inteladdress);
	lds R16,_inteladdress
	lds R17,_inteladdress+1
	rcall _ConvertFlashAddress
	.dbline 303
	clr R20
	rjmp L74
L71:
	.dbline 303
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	rcall _SPI_MasterTransmit
L72:
	.dbline 303
	inc R20
L74:
	.dbline 303
; //	 FlashAddress[0] = 0x00;
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	cpi R20,3
	brlo L71
	.dbline 305
	clr R20
	rjmp L78
L75:
	.dbline 305
	ldi R24,<_intelbinary
	ldi R25,>_intelbinary
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	rcall _SPI_MasterTransmit
L76:
	.dbline 305
	inc R20
L78:
	.dbline 305
; 	 
; 	 for(i=0; i<bytesonline; i++)  SPI_MasterTransmit(intelbinary[i]);
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R20
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L75
	.dbline 308
; 	 
; 	 // Serial Flash CS high
; 	 FlashChipSelect(HIGH);
	ldi R16,1
	rcall _FlashChipSelect
	.dbline -2
L68:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r i 20 c
	.dbsym r bufferid 20 c
	.dbend
	.dbfunc e LoadFlashPage _LoadFlashPage fV
;              i -> R20
;       bufferid -> R20
	.even
_LoadFlashPage::
	rcall push_gset1
	mov R20,R16
	.dbline -1
	.dbline 312
; }
; 
; void LoadFlashPage(unsigned char bufferid)
; {
	.dbline 316
;      unsigned char i;
; 	 
; 	 // Serial Flash CS low
; 	 FlashChipSelect(LOW);    
	ldi R16,2
	rcall _FlashChipSelect
	.dbline 319
; 	 
; 	 //  Buffer write
; 	 if(bufferid==1)  SPI_MasterTransmit(SF_FLASH_TO_BUF1);
	cpi R20,1
	brne L80
	.dbline 319
	ldi R16,83
	rcall _SPI_MasterTransmit
	rjmp L81
L80:
	.dbline 320
; 	 else  SPI_MasterTransmit(SF_FLASH_TO_BUF2);
	ldi R16,85
	rcall _SPI_MasterTransmit
L81:
	.dbline 323
; 	 
; 	 // Convert address to 24 bit address
; 	 ConvertFlashAddress(inteladdress);
	lds R16,_inteladdress
	lds R17,_inteladdress+1
	rcall _ConvertFlashAddress
	.dbline 325
	clr R20
	rjmp L85
L82:
	.dbline 325
	ldi R24,<_FlashAddress
	ldi R25,>_FlashAddress
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	rcall _SPI_MasterTransmit
L83:
	.dbline 325
	inc R20
L85:
	.dbline 325
; //	 FlashAddress[0] = 0x00;
; 	 for(i=0; i<3; i++)  SPI_MasterTransmit(FlashAddress[i]);
	cpi R20,3
	brlo L82
	.dbline 328
; 	 
; 	 // Serial Flash CS high
; 	 FlashChipSelect(HIGH);
	ldi R16,1
	rcall _FlashChipSelect
	.dbline -2
L79:
	rcall pop_gset1
	.dbline 0 ; func end
	ret
	.dbsym r i 20 c
	.dbsym r bufferid 20 c
	.dbend
	.dbfunc e WaitForFlashFree _WaitForFlashFree fV
	.even
_WaitForFlashFree::
	.dbline -1
	.dbline 333
;     
; }
; 
; void  WaitForFlashFree(void)
; { 	  
L87:
	.dbline 334
L88:
	.dbline 334
; 	  while(!(SPI_SerialFlashStatus()&0x80)) ;
	rcall _SPI_SerialFlashStatus
	mov R24,R16
	andi R24,128
	breq L87
	.dbline -2
L86:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e ProgramSerialFlash _ProgramSerialFlash fV
;   shortbytecnt -> R10,R11
;   shortaddress -> y+4
;       newpage2 -> y+8
;        newpage -> R10,R11
;  globaladdress -> y+0
; firstbytesonline -> R12,R13
;     newbytecnt -> R14,R15
;              i -> R10,R11
	.even
_ProgramSerialFlash::
	rcall push_gset5
	sbiw R28,10
	.dbline -1
	.dbline 355
; }
; 
; //  Main Serial Flash programming state controller
; //
; //  Serial flash chips are programmed one page at a time.  Each flash chip
; //  has two SRAM buffers.  Due to AVR limitations programming data is first
; //  loaded into the SRAM buffers then transferred to Flash.  SRAM buffers 
; //  range in size from 264 to 1024 bytes so the state machine must keep track
; //  of different buffer sizes.  IntelHex records range in size from 1 to 32
; //  bytes (AVR limitation) and can arrive at any start address.
; //
; //  As IntelHex records are received on the serial channel they are first
; //  loaded into Flash SRAM (AVR doesn't have enough SRAM available) and then
; //  written to a Flash page if a termination record is received or the SRAM 
; //  buffer becomes full.  To prevent Flash overwrite a Flash page is first 
; //  loaded into SRAM and new data overwritten in SRAM.  
; //
; //  To reduce variable use bytesonline, inteladdress and intelsuperaddress
; //  are global variables.
; void ProgramSerialFlash(void)
; {
	.dbline 359
;  	 long globaladdress,shortaddress;
; 	 int newpage,newpage2,shortbytecnt,newbytecnt,i,firstbytesonline;
; 	 
; 	 globaladdress = intelsuperaddress*65536 + inteladdress;
	lds R2,_intelsuperaddress
	lds R3,_intelsuperaddress+1
	clr R4
	clr R5
	ldi R20,0
	ldi R21,0
	ldi R22,1
	ldi R23,0
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	movw R16,R20
	movw R18,R22
	rcall empy32s
	movw R2,R16
	movw R4,R18
	lds R6,_inteladdress
	lds R7,_inteladdress+1
	clr R8
	clr R9
	add R2,R6
	adc R3,R7
	adc R4,R8
	adc R5,R9
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	.dbline 360
; 	 newpage = globaladdress/flashpagesize0;
	lds R2,_flashpagesize0
	lds R3,_flashpagesize0+1
	clr R4
	clr R5
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	rcall div32s
	movw R10,R16
	.dbline 361
; 	 oldinteladdress = inteladdress;
	lds R2,_inteladdress
	lds R3,_inteladdress+1
	sts _oldinteladdress+1,R3
	sts _oldinteladdress,R2
	.dbline 365
; //	 puts(" ga="); PrintWordHex(inteladdress); putchar(' ');
; 	 
;      // Always load flash page for first record
;  	 if(flashprogrammingactive==NO) {
	lds R2,_flashprogrammingactive
	tst R2
	brne L91
	.dbline 365
	.dbline 366
; 	     totalbytecnt = 0;
	clr R2
	clr R3
	sts _totalbytecnt+1,R3
	sts _totalbytecnt,R2
	.dbline 367
; 		 LoadFlashPage(1);
	ldi R16,1
	rcall _LoadFlashPage
	.dbline 368
; 		 WaitForFlashFree();  // wait for page transfer to complete 250usec
	rcall _WaitForFlashFree
	.dbline 369
; 	     flashprogrammingactive = YES;
	ldi R24,1
	sts _flashprogrammingactive,R24
	.dbline 370
; 		 flashpageloaded = YES;
	sts _flashpageloaded,R24
	.dbline 371
; 		 oldpage = newpage;
	sts _oldpage+1,R11
	sts _oldpage,R10
	.dbline 372
; 		 }
	rjmp L92
L91:
	.dbline 376
; 
;  	 // See if flash page was loaded - preserves old data not in the new
; 	 // record from being overwritten
;  	 else if(flashpageloaded==NO)  {
	lds R2,_flashpageloaded
	tst R2
	brne L93
	.dbline 376
	.dbline 377
; 	     LoadFlashPage(1);
	ldi R16,1
	rcall _LoadFlashPage
	.dbline 378
; 		 WaitForFlashFree();  // wait for programming to complete - 20msec
	rcall _WaitForFlashFree
	.dbline 379
; 		 flashpageloaded = YES;
	ldi R24,1
	sts _flashpageloaded,R24
	.dbline 380
; 		 }
L93:
L92:
	.dbline 385
; 		 
; 	 // See if number of bytes in record causes a page boundary traverse
; 	 //  tbd - what if buffer fills exactly?
; //	 newbytecnt = bytesonline;
; 	 newpage2 = (globaladdress+bytesonline)/flashpagesize0;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	clr R4
	clr R5
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
	add R16,R2
	adc R17,R3
	adc R18,R4
	adc R19,R5
	lds R2,_flashpagesize0
	lds R3,_flashpagesize0+1
	clr R4
	clr R5
	st -y,R5
	st -y,R4
	st -y,R3
	st -y,R2
	rcall div32s
	std y+9,R17
	std y+8,R16
	.dbline 386
; 	 shortaddress = newpage*flashpagesize0;	 
	lds R18,_flashpagesize0
	lds R19,_flashpagesize0+1
	movw R16,R10
	rcall empy16s
	movw R2,R16
	clr R4
	clr R5
	std y+4,R2
	std y+5,R3
	std y+6,R4
	std y+7,R5
	.dbline 392
; //     if((globaladdress+bytesonline-1)==(shortaddress+flashpagesize0-1)) {
; //	    puts(" yureka ");
; //		printf(" ad=%x ",inteladdress);
; //		}
; 
; 	 if(newpage!=newpage2) {
	ldd R0,y+8
	ldd R1,y+9
	cp R10,R0
	cpc R11,R1
	breq L95
	.dbline 392
	.dbline 393
; 	     flashpageboundarytraversed = YES;
	ldi R24,1
	sts _flashpageboundarytraversed,R24
	.dbline 394
; 	     shortbytecnt = flashpagesize0 - (globaladdress - shortaddress);
	ldd R2,y+4
	ldd R3,y+5
	ldd R4,y+6
	ldd R5,y+7
	ldd R6,y+0
	ldd R7,y+1
	ldd R8,y+2
	ldd R9,y+3
	sub R6,R2
	sbc R7,R3
	sbc R8,R4
	sbc R9,R5
	lds R2,_flashpagesize0
	lds R3,_flashpagesize0+1
	clr R4
	clr R5
	sub R2,R6
	sbc R3,R7
	sbc R4,R8
	sbc R5,R9
	movw R10,R2
	.dbline 395
; 	     newbytecnt = bytesonline - shortbytecnt;
	lds R14,_bytesonline
	lds R15,_bytesonline+1
	sub R14,R2
	sbc R15,R3
	.dbline 397
; //		 printf(" ad=%x ",inteladdress);
; 		 firstbytesonline = bytesonline;
	lds R12,_bytesonline
	lds R13,_bytesonline+1
	.dbline 398
; 		 bytesonline = shortbytecnt;
	sts _bytesonline+1,R11
	sts _bytesonline,R10
	.dbline 400
; //		 printf(" sc=%d %d ",shortbytecnt,newbytecnt);
; 		 }
L95:
	.dbline 402
; 	 
; 	 totalbytecnt += bytesonline;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	lds R4,_totalbytecnt
	lds R5,_totalbytecnt+1
	add R4,R2
	adc R5,R3
	sts _totalbytecnt+1,R5
	sts _totalbytecnt,R4
	.dbline 403
; 	 ProgramFlashBuffer(1); 
	ldi R16,1
	rcall _ProgramFlashBuffer
	.dbline 405
; //	 printf(" lb=%d",totalbytecnt); 
; 	 flashdatainbuffer = YES;
	ldi R24,1
	sts _flashdatainbuffer,R24
	.dbline 408
	tst R14
	brne X2
	tst R15
	breq L99
X2:
	lds R24,_flashpageboundarytraversed
	cpi R24,1
	brne L97
L99:
	.dbline 408
; 	 
; 	 //  If Buffer full or boundary traversed transfer buffer to flash
; 	 if((newbytecnt==0)||(flashpageboundarytraversed==YES))  {
	.dbline 409
; 	     ProgramBuffertoPageErase(1);
	ldi R16,1
	rcall _ProgramBuffertoPageErase
	.dbline 410
; 		 WaitForFlashFree();  // wait for programming to complete - 20msec
	rcall _WaitForFlashFree
	.dbline 411
; 		 flashpageloaded = NO;
	clr R2
	sts _flashpageloaded,R2
	.dbline 412
; 		 flashdatainbuffer = NO;
	sts _flashdatainbuffer,R2
	.dbline 414
; //		 printf(" fp=%d",newpage); 
; 		 }
L97:
	.dbline 417
; 	 
; 	 //  If record caused a page boundary traversal load next page
; 	 if(flashpageboundarytraversed==YES) {
	lds R24,_flashpageboundarytraversed
	cpi R24,1
	breq X3
	rjmp L100
X3:
	.dbline 417
	.dbline 419
; 	     //newpage++;       // goto next page
; 		 oldpage = newpage2;
	ldd R0,y+8
	ldd R1,y+9
	sts _oldpage+1,R1
	sts _oldpage,R0
	.dbline 421
; //		 printf(" tp=%d ",newpage);
; 		 inteladdress = newpage2*flashpagesize0;  // start address at page bdry
	lds R18,_flashpagesize0
	lds R19,_flashpagesize0+1
	movw R16,R0
	rcall empy16s
	sts _inteladdress+1,R17
	sts _inteladdress,R16
	.dbline 422
; 	 	 oldinteladdress = inteladdress;
	movw R2,R16
	sts _oldinteladdress+1,R3
	sts _oldinteladdress,R2
	.dbline 423
; 		 LoadFlashPage(1);   // Load the new page - this may be last record
	ldi R16,1
	rcall _LoadFlashPage
	.dbline 425
; 		                     // So don't overwrite remaining content in page
; 		 WaitForFlashFree();  // wait for page transfer to complete 250usec
	rcall _WaitForFlashFree
	.dbline 426
; 		 flashpageloaded = YES;  // Page loaded so don't do it again next recrd
	ldi R24,1
	sts _flashpageloaded,R24
	.dbline 427
; 		 for(i=0; i<newbytecnt; i++)  // Shift record data to start
	clr R10
	clr R11
	rjmp L105
L102:
	.dbline 428
	movw R30,R12
	sub R30,R14
	sbc R31,R15
	add R30,R10
	adc R31,R11
	ldi R24,<_intelbinary
	ldi R25,>_intelbinary
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	movw R30,R10
	add R30,R24
	adc R31,R25
	std z+0,R2
L103:
	.dbline 427
	movw R24,R10
	adiw R24,1
	movw R10,R24
L105:
	.dbline 427
	cp R10,R14
	cpc R11,R15
	brlt L102
	.dbline 429
	sts _bytesonline+1,R15
	sts _bytesonline,R14
	.dbline 431
	ldi R16,1
	rcall _ProgramFlashBuffer
	.dbline 432
	ldi R24,1
	sts _flashdatainbuffer,R24
	.dbline 433
	lds R2,_totalbytecnt
	lds R3,_totalbytecnt+1
	add R2,R14
	adc R3,R15
	sts _totalbytecnt+1,R3
	sts _totalbytecnt,R2
	.dbline 434
	clr R2
	sts _flashpageboundarytraversed,R2
	.dbline 435
L100:
	.dbline -2
L90:
	adiw R28,10
	rcall pop_gset5
	.dbline 0 ; func end
	ret
	.dbsym r shortbytecnt 10 I
	.dbsym l shortaddress 4 L
	.dbsym l newpage2 8 I
	.dbsym r newpage 10 I
	.dbsym l globaladdress 0 L
	.dbsym r firstbytesonline 12 I
	.dbsym r newbytecnt 14 I
	.dbsym r i 10 I
	.dbend
	.dbfunc e FlashPageSize _FlashPageSize fI
;       sizecode -> R16
	.even
_FlashPageSize::
	.dbline -1
	.dbline 440
; 		      intelbinary[i] = intelbinary[firstbytesonline-newbytecnt+i];
; 		 bytesonline = newbytecnt;  // Only write new data in record
; //		 printf(" newcnt=",newbytecnt);
; 		 ProgramFlashBuffer(1);  // write remaining record to RAM buffer
; 		 flashdatainbuffer = YES;
; 		 totalbytecnt += newbytecnt;
; 		 flashpageboundarytraversed=NO;
; 	     }
; }
; 
; // Return Serial Flash page size
; int FlashPageSize(unsigned char sizecode)
; {
	.dbline 441
	cpi R16,28
	breq L109
	cpi R16,36
	brne L107
L109:
	.dbline 441
;  	 if((sizecode==AT45DB041ID)||(sizecode==AT45DB081ID))  return 264;
	ldi R16,264
	ldi R17,1
	rjmp L106
L107:
	.dbline 442
	cpi R16,44
	breq L112
	cpi R16,52
	brne L110
L112:
	.dbline 442
; 	 else if((sizecode==AT45DB161ID)||(sizecode==AT45DB321ID)) return 528;
	ldi R16,528
	ldi R17,2
	rjmp L106
L110:
	.dbline 443
; 	 else if(sizecode==AT45DB642ID) return 1024;
	cpi R16,36
	brne L113
	.dbline 443
	ldi R16,1024
	ldi R17,4
	rjmp L106
L113:
	.dbline 444
; 	 else return 0;
	clr R16
	clr R17
	.dbline -2
L106:
	.dbline 0 ; func end
	ret
	.dbsym r sizecode 16 c
	.dbend
	.dbfunc e CheckFlashTypes _CheckFlashTypes fV
	.even
_CheckFlashTypes::
	.dbline -1
	.dbline 451
; }
; 
; //  Search for serial flash chips U2, U5
; //  U2 is always present while U5 is optional
; //  This routine initializes SPI and resets Blackfin
; void  CheckFlashTypes()
; {
	.dbline 452
; 	Release_SPI();
	rcall _Release_SPI
	.dbline 453
; 	Init_SPI_Master();
	rcall _Init_SPI_Master
	.dbline 454
; 	flashtype0 = SPI_SerialFlashStatus()&FLASHIDMASK;
	rcall _SPI_SerialFlashStatus
	mov R24,R16
	andi R24,60
	sts _flashtype0,R24
	.dbline 455
; 	flashpagesize0 = FlashPageSize(flashtype0);		
	mov R16,R24
	rcall _FlashPageSize
	sts _flashpagesize0+1,R17
	sts _flashpagesize0,R16
	.dbline 456
; 	Release_SPI();
	rcall _Release_SPI
	.dbline -2
L115:
	.dbline 0 ; func end
	ret
	.dbend
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Stephen\Desktop\LED8CO~1\LED8_SPI_Flash.c
L37:
	.blkb 3
	.area idata
	.byte 32,32,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Stephen\Desktop\LED8CO~1\LED8_SPI_Flash.c
L32:
	.blkb 3
	.area idata
	.byte 48,48,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Stephen\Desktop\LED8CO~1\LED8_SPI_Flash.c
