	.module LED8_Utilities.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\LED8CO~1\LED8_Utilities.c
	.dbfunc e Delay _Delay fV
;              a -> R16
;              b -> R18
	.even
_Delay::
	.dbline -1
	.dbline 74
; /**************************************************************
; 
;    Program Title:  Led8 Controller
;    
;    Program Name:  LED8_Utilities.c	  Version: 0.85
;    
;    Author:  SS	  					  Date:  August 10, 2005
;    
;    Compiled with ImageCraft ICCAVR Standard V7.02
;    
;    This file contains routines that implement a set of basic utility 
;    functions for the Wasp Monitor.
;    
;    Copyright 2004-2006, SOC Robotics, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright 2004-2006, SOC Robotics, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC MACHINES, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-robotics.com
;  */
; 
; /*
;  * $Log: Wasp_Monitor.c,v $
;  * Revision 0.86  2006/02/07  SS
;  *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom48v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; //#include <stdio.h>
; #include "LED8_Uart.h"
; #include "LED8_Defines.h"
; #include "LED8_Extern.h"
; 
; //*********************************************************
; //*********************************************************
; //      Utilities
; //*********************************************************
; //*********************************************************
; void Delay(void)
; {
	.dbline 77
; 	unsigned char a, b;
; 
; 	for (a = 1; a; a++)
	ldi R16,1
	xjmp L5
L2:
	.dbline 78
; 		for (b = 1; b; b++)
	ldi R18,1
	xjmp L9
L6:
	.dbline 79
; 			;
L7:
	.dbline 78
	inc R18
L9:
	.dbline 78
	tst R18
	brne L6
X0:
L3:
	.dbline 77
	inc R16
L5:
	.dbline 77
	tst R16
	brne L2
X1:
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbsym r a 16 c
	.dbsym r b 18 c
	.dbend
	.dbfunc e ShortDelay _ShortDelay fV
;         inbyte -> R22
;              i -> R20,R21
;            cnt -> R16,R17
	.even
_ShortDelay::
	xcall push_xgsetF000
	.dbline -1
	.dbline 83
; }
; 
; void ShortDelay(int cnt)
; {
	.dbline 87
;  	unsigned char inbyte;
; 	int i;
; 	
;     for(i=0; i<cnt; i++)  {
	clr R20
	clr R21
	xjmp L14
L11:
	.dbline 87
	.dbline 88
; 	    inbyte = 0x55;
	ldi R22,85
	.dbline 89
; 		}
L12:
	.dbline 87
	subi R20,255  ; offset = 1
	sbci R21,255
L14:
	.dbline 87
	cp R20,R16
	cpc R21,R17
	brlt L11
X2:
	.dbline -2
L10:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r inbyte 22 c
	.dbsym r i 20 I
	.dbsym r cnt 16 I
	.dbend
	.dbfunc e LongDelay _LongDelay fV
;            cnt -> R20,R21
	.even
_LongDelay::
	st -y,R20
	st -y,R21
	movw R20,R16
	.dbline -1
	.dbline 93
; }
; 
; void LongDelay(int cnt)
; {
	xjmp L17
L16:
	.dbline 94
;  	 while(cnt > 0) {
	.dbline 95
; 	 	 Delay();
	xcall _Delay
	.dbline 96
; 		 cnt--;
	subi R20,1
	sbci R21,0
	.dbline 97
; 		 }
L17:
	.dbline 94
	clr R2
	clr R3
	cp R2,R20
	cpc R3,R21
	brlt L16
X3:
	.dbline -2
L15:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
	.dbsym r cnt 20 I
	.dbend
	.dbfunc e Delaymsec _Delaymsec fV
;     delayvalue -> R16,R17
	.even
_Delaymsec::
	.dbline -1
	.dbline 101
; }
; 
; void Delaymsec(int delayvalue)
; {
	.dbline 102
;  	 mseccountdown2 = delayvalue;
	sts _mseccountdown2+1,R17
	sts _mseccountdown2,R16
L20:
	.dbline 103
; 	 while(mseccountdown2) ;
L21:
	.dbline 103
	lds R2,_mseccountdown2
	lds R3,_mseccountdown2+1
	tst R2
	brne L20
	tst R3
	brne L20
X4:
	.dbline -2
L19:
	.dbline 0 ; func end
	ret
	.dbsym r delayvalue 16 I
	.dbend
	.dbfunc e RTEEPROMwrite _RTEEPROMwrite fV
;      savedSREG -> R10
;       databyte -> R18
;       location -> R16,R17
	.even
_RTEEPROMwrite::
	st -y,R10
	.dbline -1
	.dbline 110
; }
; 
; // Function to initiate an EEPROM write
; // writes the specified data byte to the specified location
; // this will fail if the EEPROM is not ready!
; void RTEEPROMwrite(int location, unsigned char databyte)
; {
	.dbline 112
; 	unsigned char savedSREG;
; 	EEAR = location;								// set address
	out 0x22,R17
	out 0x21,R16
	.dbline 113
; 	EEDR = databyte;								// set data	
	out 0x20,R18
	.dbline 114
; 	savedSREG = SREG;								// keep setting so it can be restored
	in R10,0x3f
	.dbline 115
; 	CLI();													// disable interrupts
	cli
	.dbline 116
; 	EECR |= BIT(EEMWE);							// set "write enable" bit
	sbi 0x1f,2
	.dbline 117
; 	EECR |= BIT(EEWE);							// set "write" bit
	sbi 0x1f,1
	.dbline 118
; 	SREG = savedSREG;								// restore SREG
	out 0x3f,R10
	.dbline 119
; 	EEAR = 0;
	clr R2
	clr R3
	out 0x22,R3
	out 0x21,R2
	.dbline -2
L23:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r savedSREG 10 c
	.dbsym r databyte 18 c
	.dbsym r location 16 I
	.dbend
	.dbfunc e EEPROMWrite _EEPROMWrite fV
;       databyte -> R12
;       location -> R10,R11
	.even
_EEPROMWrite::
	xcall push_xgset003C
	mov R12,R18
	movw R10,R16
	.dbline -1
	.dbline 125
; }
; 
; // EEPROM writes take about 8ms - so poll until done
; // Do not use ICC V7 function EEPROMwrite() - this routine turns interrupts off!
; void EEPROMWrite(int location, unsigned char databyte)
; {
L25:
	.dbline 126
;  	 while(!RTEEPROMReady())  ;
L26:
	.dbline 126
	xcall _RTEEPROMReady
	cpi R16,0
	cpc R16,R17
	breq L25
X5:
	.dbline 127
;  	 RTEEPROMwrite(location,databyte);
	mov R18,R12
	movw R16,R10
	xcall _RTEEPROMwrite
L28:
	.dbline 128
;  	 while(!RTEEPROMReady())  ;
L29:
	.dbline 128
	xcall _RTEEPROMReady
	cpi R16,0
	cpc R16,R17
	breq L28
X6:
	.dbline -2
L24:
	.dbline 0 ; func end
	xjmp pop_xgset003C
	.dbsym r databyte 12 c
	.dbsym r location 10 I
	.dbend
	.dbfunc e hextobyte _hextobyte fc
;         inbyte -> R16
	.even
_hextobyte::
	xcall push_xgsetF000
	.dbline -1
	.dbline 132
; }
; 
; unsigned char hextobyte(unsigned char inbyte)
; {
	.dbline 133
; 	 if((inbyte >= 'A')&(inbyte<='F')) return (inbyte - 'A' + 10);
	cpi R16,65
	brlo L34
X7:
	ldi R22,1
	ldi R23,0
	xjmp L35
L34:
	clr R22
	clr R23
L35:
	ldi R24,70
	cp R24,R16
	brlo L36
X8:
	ldi R20,1
	ldi R21,0
	xjmp L37
L36:
	clr R20
	clr R21
L37:
	movw R2,R22
	and R2,R20
	and R3,R21
	tst R2
	brne X9
	tst R3
	breq L32
X9:
	.dbline 133
	mov R24,R16
	subi R24,65
	subi R24,246    ; addi 10
	mov R16,R24
	xjmp L31
L32:
	.dbline 134
; 	 if((inbyte >= 'a')&(inbyte<='f')) return (inbyte - 'a' + 10);
	cpi R16,97
	brlo L40
X10:
	ldi R22,1
	ldi R23,0
	xjmp L41
L40:
	clr R22
	clr R23
L41:
	ldi R24,102
	cp R24,R16
	brlo L42
X11:
	ldi R20,1
	ldi R21,0
	xjmp L43
L42:
	clr R20
	clr R21
L43:
	movw R2,R22
	and R2,R20
	and R3,R21
	tst R2
	brne X12
	tst R3
	breq L38
X12:
	.dbline 134
	mov R24,R16
	subi R24,97
	subi R24,246    ; addi 10
	mov R16,R24
	xjmp L31
L38:
	.dbline 135
; 	 else return (inbyte - '0');
	subi R16,48
	.dbline -2
L31:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r inbyte 16 c
	.dbend
	.dbfunc e RTEEPROMReady _RTEEPROMReady fc
	.even
_RTEEPROMReady::
	.dbline -1
	.dbline 141
; }
; 
; // function to test if the EEPROM is ready for a read or write operation
; // returns non zero if ready, zero if not ready 
; unsigned char RTEEPROMReady(void)
; {
	.dbline 142
; 	return !(EECR & 0x02);
	sbic 0x1f,1
	rjmp L45
X13:
	ldi R16,1
	ldi R17,0
	xjmp L46
L45:
	clr R16
	clr R17
L46:
	.dbline -2
L44:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e LED_Power _LED_Power fV
;          state -> R18
;      ledselect -> R16,R17
	.even
_LED_Power::
	.dbline -1
	.dbline 146
; }
; 
; void LED_Power(int ledselect,char state)
; {
	.dbline 147
;  	 if(ledselect==LED1) {
	cpi R16,1
	ldi R30,0
	cpc R17,R30
	brne L48
X14:
	.dbline 147
	.dbline 148
; 	 	if(state==ON)  SetBit(PORTD,PIND2);
	tst R18
	brne L50
X15:
	.dbline 148
	sbi 0xb,2
	xjmp L49
L50:
	.dbline 149
; 		else  ClrBit(PORTD,PIND2);
	cbi 0xb,2
	.dbline 150
; 		}
	xjmp L49
L48:
	.dbline 151
;  	 else if(ledselect==LED2) {
	cpi R16,2
	ldi R30,0
	cpc R17,R30
	brne L52
X16:
	.dbline 151
	.dbline 152
; 	 	if(state==ON)  SetBit(PORTD,PIND3);
	tst R18
	brne L54
X17:
	.dbline 152
	sbi 0xb,3
	xjmp L53
L54:
	.dbline 153
; 		else  ClrBit(PORTD,PIND3);
	cbi 0xb,3
	.dbline 154
; 		}
	xjmp L53
L52:
	.dbline 155
;  	 else if(ledselect==LED3) {
	cpi R16,3
	ldi R30,0
	cpc R17,R30
	brne L56
X18:
	.dbline 155
	.dbline 156
; 	 	if(state==ON)  SetBit(PORTD,PIND4);
	tst R18
	brne L58
X19:
	.dbline 156
	sbi 0xb,4
	xjmp L57
L58:
	.dbline 157
; 		else  ClrBit(PORTD,PIND4);
	cbi 0xb,4
	.dbline 158
; 		}
	xjmp L57
L56:
	.dbline 159
;  	 else if(ledselect==LED4) {
	cpi R16,4
	ldi R30,0
	cpc R17,R30
	brne L60
X20:
	.dbline 159
	.dbline 160
; 	 	if(state==ON)  SetBit(PORTD,PIND5);
	tst R18
	brne L62
X21:
	.dbline 160
	sbi 0xb,5
	xjmp L61
L62:
	.dbline 161
; 		else  ClrBit(PORTD,PIND5);
	cbi 0xb,5
	.dbline 162
; 		}
	xjmp L61
L60:
	.dbline 163
;  	 else if(ledselect==LED5) {
	cpi R16,5
	ldi R30,0
	cpc R17,R30
	brne L64
X22:
	.dbline 163
	.dbline 164
; 	 	if(state==ON)  SetBit(PORTD,PIND6);
	tst R18
	brne L66
X23:
	.dbline 164
	sbi 0xb,6
	xjmp L65
L66:
	.dbline 165
; 		else  ClrBit(PORTD,PIND6);
	cbi 0xb,6
	.dbline 166
; 		}
	xjmp L65
L64:
	.dbline 167
;  	 else if(ledselect==LED6) {
	cpi R16,6
	ldi R30,0
	cpc R17,R30
	brne L68
X24:
	.dbline 167
	.dbline 168
; 	 	if(state==ON)  SetBit(PORTD,PIND7);
	tst R18
	brne L70
X25:
	.dbline 168
	sbi 0xb,7
	xjmp L69
L70:
	.dbline 169
; 		else  ClrBit(PORTD,PIND7);
	cbi 0xb,7
	.dbline 170
; 		}
	xjmp L69
L68:
	.dbline 172
; // 	 New PCB
; 	 else if(ledselect==LED7) {
	cpi R16,7
	ldi R30,0
	cpc R17,R30
	brne L72
X26:
	.dbline 172
	.dbline 173
; 	 	if(state==ON)  SetBit(PORTB,PINB5);
	tst R18
	brne L74
X27:
	.dbline 173
	sbi 0x5,5
	xjmp L73
L74:
	.dbline 174
; 		else  ClrBit(PORTB,PINB5);
	cbi 0x5,5
	.dbline 175
; 		}
	xjmp L73
L72:
	.dbline 176
;  	 else if(ledselect==LED8) {
	cpi R16,8
	ldi R30,0
	cpc R17,R30
	brne L76
X28:
	.dbline 176
	.dbline 177
; 	 	if(state==ON)  SetBit(PORTB,PINB4);
	tst R18
	brne L78
X29:
	.dbline 177
	sbi 0x5,4
	xjmp L79
L78:
	.dbline 178
; 		else  ClrBit(PORTB,PINB4);
	cbi 0x5,4
L79:
	.dbline 179
; 		} 
L76:
L73:
L69:
L65:
L61:
L57:
L53:
L49:
	.dbline -2
L47:
	.dbline 0 ; func end
	ret
	.dbsym r state 18 c
	.dbsym r ledselect 16 I
	.dbend
	.dbfunc e Set_LED_Segments _Set_LED_Segments fV
;        ledbyte -> R16
	.even
_Set_LED_Segments::
	.dbline -1
	.dbline 195
; 
; /*   Old PCB
;  	 else if(ledselect==LED7) {
; 	 	if(state==ON)  SetBit(PORTB,PINB6);
; 		else  ClrBit(PORTB,PINB6);
; 		}
;  	 else if(ledselect==LED8) {
; 	 	if(state==ON)  SetBit(PORTB,PINB7);
; 		else  ClrBit(PORTB,PINB7);
; 		}
; */
; }
; 
; //  Use PortB bit 0
; void  Set_LED_Segments(unsigned char ledbyte)
; {
	.dbline 196
; 	 if(ledbyte&0x01) SetBit(PORTC,PINC0);
	sbrs R16,0
	rjmp L81
X30:
	.dbline 196
	sbi 0x8,0
	xjmp L82
L81:
	.dbline 197
; 	 else ClrBit(PORTC,PINC0);
	cbi 0x8,0
L82:
	.dbline 198
; 	 if(ledbyte&0x02) SetBit(PORTC,PINC1);
	sbrs R16,1
	rjmp L83
X31:
	.dbline 198
	sbi 0x8,1
	xjmp L84
L83:
	.dbline 199
; 	 else ClrBit(PORTC,PINC1);
	cbi 0x8,1
L84:
	.dbline 200
; 	 if(ledbyte&0x04) SetBit(PORTC,PINC2);
	sbrs R16,2
	rjmp L85
X32:
	.dbline 200
	sbi 0x8,2
	xjmp L86
L85:
	.dbline 201
; 	 else ClrBit(PORTC,PINC2);
	cbi 0x8,2
L86:
	.dbline 202
; 	 if(ledbyte&0x08) SetBit(PORTC,PINC3);
	sbrs R16,3
	rjmp L87
X33:
	.dbline 202
	sbi 0x8,3
	xjmp L88
L87:
	.dbline 203
; 	 else ClrBit(PORTC,PINC3);
	cbi 0x8,3
L88:
	.dbline 204
; 	 if(ledbyte&0x10) SetBit(PORTB,PINB1);
	sbrs R16,4
	rjmp L89
X34:
	.dbline 204
	sbi 0x5,1
	xjmp L90
L89:
	.dbline 205
; 	 else ClrBit(PORTB,PINB1);
	cbi 0x5,1
L90:
	.dbline 206
; 	 if(ledbyte&0x20) SetBit(PORTB,PINB3);
	sbrs R16,5
	rjmp L91
X35:
	.dbline 206
	sbi 0x5,3
	xjmp L92
L91:
	.dbline 207
; 	 else ClrBit(PORTB,PINB3);
	cbi 0x5,3
L92:
	.dbline 208
; 	 if(ledbyte&0x40) SetBit(PORTB,PINB0);
	sbrs R16,6
	rjmp L93
X36:
	.dbline 208
	sbi 0x5,0
	xjmp L94
L93:
	.dbline 209
; 	 else ClrBit(PORTB,PINB0);
	cbi 0x5,0
L94:
	.dbline -2
L80:
	.dbline 0 ; func end
	ret
	.dbsym r ledbyte 16 c
	.dbend
	.dbfunc e Decimal_Point _Decimal_Point fV
;          state -> R16
	.even
_Decimal_Point::
	.dbline -1
	.dbline 213
; }
; 
; void  Decimal_Point(char state)
; {
	.dbline 214
; 	 if(state==ON)  ClrBit(PORTB,PINB2);
	tst R16
	brne L96
X37:
	.dbline 214
	cbi 0x5,2
	xjmp L97
L96:
	.dbline 215
; 	 else  SetBit(PORTB,PINB2);
	sbi 0x5,2
L97:
	.dbline -2
L95:
	.dbline 0 ; func end
	ret
	.dbsym r state 16 c
	.dbend
	.dbfunc e Cycle_LED _Cycle_LED fV
;              i -> R20,R21
;      ledselect -> R10,R11
	.even
_Cycle_LED::
	xcall push_xgset300C
	movw R10,R16
	.dbline -1
	.dbline 219
; }
; 
; void  Cycle_LED(int ledselect)
; {
	.dbline 222
;  	int i;
; 	
; 	LED_Power(ledselect,ON);
	clr R18
	movw R16,R10
	xcall _LED_Power
	.dbline 223
; 	for(i=0; i<10; i++)  {
	clr R20
	clr R21
L99:
	.dbline 223
	.dbline 224
; 		 Set_LED_Segments(~ledchars[i]);
	ldi R24,<_ledchars
	ldi R25,>_ledchars
	movw R30,R20
	lsl R30
	rol R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	com R16
	com R17
	xcall _Set_LED_Segments
	.dbline 225
; 		 ShortDelay(10000);
	ldi R16,10000
	ldi R17,39
	xcall _ShortDelay
	.dbline 226
; 		 }
L100:
	.dbline 223
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 223
	cpi R20,10
	ldi R30,0
	cpc R21,R30
	brlt L99
X38:
	.dbline 227
; 	LED_Power(ledselect,OFF);
	ldi R18,1
	movw R16,R10
	xcall _LED_Power
	.dbline -2
L98:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r i 20 I
	.dbsym r ledselect 10 I
	.dbend
	.dbfunc e Display_Number_Fast _Display_Number_Fast fV
;       delaynum -> R20,R21
;   decimalpoint -> R22,R23
;        numstrg -> R10,R11
	.even
_Display_Number_Fast::
	xcall push_xgsetF00C
	movw R22,R18
	movw R10,R16
	.dbline -1
	.dbline 233
; }
; 
; 
; // Display number as fast as possible
; void Display_Number_Fast(char *numstrg,int decimalpoint)
; {
	.dbline 236
;  	 int delaynum;
; 	 
; 	 delaynum = 500;
	ldi R20,500
	ldi R21,1
	.dbline 237
; 	 Set_LED_Segments(~ledchars[numstrg[0]]);
	ldi R24,<_ledchars
	ldi R25,>_ledchars
	movw R30,R10
	ldd R30,z+0
	clr R31
	lsl R30
	rol R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	com R16
	com R17
	xcall _Set_LED_Segments
	.dbline 238
;  	 PORTD = LED1ON;
	ldi R24,4
	out 0xb,R24
	.dbline 239
; 	 if(decimalpoint==7) Decimal_Point(ON);
	cpi R22,7
	ldi R30,0
	cpc R23,R30
	brne L104
X39:
	.dbline 239
	clr R16
	xcall _Decimal_Point
	xjmp L105
L104:
	.dbline 240
; 	 else  Decimal_Point(OFF);
	ldi R16,1
	xcall _Decimal_Point
L105:
	.dbline 241
; 	 ShortDelay(delaynum);
	movw R16,R20
	xcall _ShortDelay
	.dbline 242
; 	 Set_LED_Segments(~ledchars[numstrg[1]]);
	ldi R24,<_ledchars
	ldi R25,>_ledchars
	movw R30,R10
	ldd R30,z+1
	clr R31
	lsl R30
	rol R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	com R16
	com R17
	xcall _Set_LED_Segments
	.dbline 243
;  	 PORTD = LED2ON;
	ldi R24,8
	out 0xb,R24
	.dbline 244
; 	 if(decimalpoint==6) Decimal_Point(ON);
	cpi R22,6
	ldi R30,0
	cpc R23,R30
	brne L106
X40:
	.dbline 244
	clr R16
	xcall _Decimal_Point
	xjmp L107
L106:
	.dbline 245
; 	 else  Decimal_Point(OFF);
	ldi R16,1
	xcall _Decimal_Point
L107:
	.dbline 246
; 	 ShortDelay(delaynum);
	movw R16,R20
	xcall _ShortDelay
	.dbline 247
;  	 LED_Power(LED2,OFF);
	ldi R18,1
	ldi R16,2
	ldi R17,0
	xcall _LED_Power
	.dbline 248
; 	 Set_LED_Segments(~ledchars[numstrg[2]]);
	ldi R24,<_ledchars
	ldi R25,>_ledchars
	movw R30,R10
	ldd R30,z+2
	clr R31
	lsl R30
	rol R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	com R16
	com R17
	xcall _Set_LED_Segments
	.dbline 249
;  	 PORTD = LED3ON;
	ldi R24,16
	out 0xb,R24
	.dbline 250
; 	 if(decimalpoint==5) Decimal_Point(ON);
	cpi R22,5
	ldi R30,0
	cpc R23,R30
	brne L108
X41:
	.dbline 250
	clr R16
	xcall _Decimal_Point
	xjmp L109
L108:
	.dbline 251
; 	 else  Decimal_Point(OFF);
	ldi R16,1
	xcall _Decimal_Point
L109:
	.dbline 252
; 	 ShortDelay(delaynum);
	movw R16,R20
	xcall _ShortDelay
	.dbline 253
; 	 Set_LED_Segments(~ledchars[numstrg[3]]);
	ldi R24,<_ledchars
	ldi R25,>_ledchars
	movw R30,R10
	ldd R30,z+3
	clr R31
	lsl R30
	rol R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	com R16
	com R17
	xcall _Set_LED_Segments
	.dbline 254
;  	 PORTD = LED4ON;
	ldi R24,32
	out 0xb,R24
	.dbline 255
; 	 if(decimalpoint==4) Decimal_Point(ON);
	cpi R22,4
	ldi R30,0
	cpc R23,R30
	brne L110
X42:
	.dbline 255
	clr R16
	xcall _Decimal_Point
	xjmp L111
L110:
	.dbline 256
; 	 else  Decimal_Point(OFF);
	ldi R16,1
	xcall _Decimal_Point
L111:
	.dbline 257
; 	 ShortDelay(delaynum);
	movw R16,R20
	xcall _ShortDelay
	.dbline 258
; 	 Set_LED_Segments(~ledchars[numstrg[4]]);
	ldi R24,<_ledchars
	ldi R25,>_ledchars
	movw R30,R10
	ldd R30,z+4
	clr R31
	lsl R30
	rol R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	com R16
	com R17
	xcall _Set_LED_Segments
	.dbline 259
;  	 PORTD = LED5ON;
	ldi R24,64
	out 0xb,R24
	.dbline 260
; 	 if(decimalpoint==3) Decimal_Point(ON);
	cpi R22,3
	ldi R30,0
	cpc R23,R30
	brne L112
X43:
	.dbline 260
	clr R16
	xcall _Decimal_Point
	xjmp L113
L112:
	.dbline 261
; 	 else  Decimal_Point(OFF);
	ldi R16,1
	xcall _Decimal_Point
L113:
	.dbline 262
; 	 ShortDelay(delaynum);
	movw R16,R20
	xcall _ShortDelay
	.dbline 263
; 	 Set_LED_Segments(~ledchars[numstrg[5]]);
	ldi R24,<_ledchars
	ldi R25,>_ledchars
	movw R30,R10
	ldd R30,z+5
	clr R31
	lsl R30
	rol R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	com R16
	com R17
	xcall _Set_LED_Segments
	.dbline 264
;  	 PORTD = LED6ON;
	ldi R24,128
	out 0xb,R24
	.dbline 265
; 	 if(decimalpoint==2) Decimal_Point(ON);
	cpi R22,2
	ldi R30,0
	cpc R23,R30
	brne L114
X44:
	.dbline 265
	clr R16
	xcall _Decimal_Point
	xjmp L115
L114:
	.dbline 266
; 	 else  Decimal_Point(OFF);
	ldi R16,1
	xcall _Decimal_Point
L115:
	.dbline 267
; 	 ShortDelay(delaynum);
	movw R16,R20
	xcall _ShortDelay
	.dbline 268
; 	 PORTD = LEDSOFF;
	clr R2
	out 0xb,R2
	.dbline 268
	.dbline 269
; 	 Set_LED_Segments(~ledchars[numstrg[6]]);
	ldi R24,<_ledchars
	ldi R25,>_ledchars
	movw R30,R10
	ldd R30,z+6
	clr R31
	lsl R30
	rol R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	com R16
	com R17
	xcall _Set_LED_Segments
	.dbline 270
;  	 PORTB |= LED7ON;
	sbi 0x5,6
	.dbline 271
; 	 if(decimalpoint==1) Decimal_Point(ON);
	cpi R22,1
	ldi R30,0
	cpc R23,R30
	brne L116
X45:
	.dbline 271
	clr R16
	xcall _Decimal_Point
	xjmp L117
L116:
	.dbline 272
; 	 else  Decimal_Point(OFF);
	ldi R16,1
	xcall _Decimal_Point
L117:
	.dbline 273
; 	 ShortDelay(delaynum);
	movw R16,R20
	xcall _ShortDelay
	.dbline 274
; 	 Set_LED_Segments(~ledchars[numstrg[7]]);
	ldi R24,<_ledchars
	ldi R25,>_ledchars
	movw R30,R10
	ldd R30,z+7
	clr R31
	lsl R30
	rol R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	com R16
	com R17
	xcall _Set_LED_Segments
	.dbline 275
; 	 PORTB &= ~LED7ON;
	cbi 0x5,6
	.dbline 276
;  	 PORTB |= LED8ON;
	sbi 0x5,7
	.dbline 277
; 	 if(decimalpoint==0) Decimal_Point(ON);
	cpi R22,0
	cpc R22,R23
	brne L118
X46:
	.dbline 277
	clr R16
	xcall _Decimal_Point
	xjmp L119
L118:
	.dbline 278
; 	 else  Decimal_Point(OFF);
	ldi R16,1
	xcall _Decimal_Point
L119:
	.dbline 279
; 	 ShortDelay(delaynum);
	movw R16,R20
	xcall _ShortDelay
	.dbline 280
; 	 PORTB &= ~LED8ON;
	cbi 0x5,7
	.dbline 281
; 	 Set_LED_Segments(0xff);
	ldi R16,255
	xcall _Set_LED_Segments
	.dbline -2
L103:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
	.dbsym r delaynum 20 I
	.dbsym r decimalpoint 22 I
	.dbsym r numstrg 10 pc
	.dbend
; }
